uses graph,{mobj,}crt,objects,colors256,math,mstring;
type
   PLGFHeader=^TLGFHeader;
   TLGFHeader=record
     FID:array [0..5] of char;{'LGFv1'}
     cent:TPoint;
     mx,my:longint;
     ltype:byte;
     col1,col2,col3,col4,col5:byte;
     wx,wy:integer;
     skip:word;{offset of image}
     {There can be a comment}
   end;

   PLGFRec=^TLGFRec;
   TLGFRec=record
     x,y:integer;
     what:byte;
   end;

const
   lgfGo           = 1;
   lgfDraw         = 2;
   lgfPoint        = 3;
   lgfFin          = 255;

   lgfID           = 'LGF!V1';

   ltSolid         = 0;
   ltDot           = 1;
   ltCent          = 2;
   ltDash          = 3;
   ltNone          = 255;

   lgSize          = SizeOf(TLGFRec);

var
    f:TLgfHeader;
    s:string;
    t:TBufStream;

var AY,AX,PX,PY:integer;x,x1,y,y1:extended;
   cx,cy:longint;
   i:longint;
   fx,fy:longint;
   r:trect;
   p:TPoint;
   mr:TLGFRec;

const dx=0;
      dy=0;
    Col1=scWhite;
    Col5=scBlack;
    Col4=scBlue;
    Col3=scCyan;
    Col2=scLightBlue;

begin
  if paramCount<>1 then begin
    writeln('Linear graph format (.lgf) files viewer v1.2. Copyright by Pasha 1st');
    writeln('Usage: lgfview[.exe] <filename.lgf>');
    exit;
  end;
  t.init(ParamStr(1),stOpenRead,8192);
  t.read(f,sizeOf(f));
  if (f.fid[0]<>'L')or(f.fid[1]<>'G')or(f.fid[2]<>'F')or(f.fid[3]<>'!')or
    (f.fid[5]<>'1') then begin
    writeln('Incorrect input file!!!');
    t.done;
    exit;
  end;
  i:=detect;
  InitGraph(integer(i),integer(i),'');
{  f.sinit;}
  t.read(s[1],IMin(f.skip,255));
  byte(s[0]):=lo(f.skip);
  t.seek(SizeOf(f)+f.skip);
  r.assign(0,0,IMin(GetMaxX,f.wx),IMin(GetMaxY,f.wy));
  fx:=r.b.x-r.a.x-1{-dx};
  fy:=r.b.y-r.a.y-1{-dy};
  SetWriteMode(NormalPut);
  SetTextJustify(CenterText, CenterText);
  setBkColor(scBlack{GCol});
  setFillStyle(SolidFill,col1);
  R.Assign(dx,dy,fx+2*dx,fY+2*dy);
  bar(r.a.x,r.a.y,r.b.x,r.b.y);
  SetLineStyle(SolidLn,0,1);

  {==============+==============}
  setColor(Col2{scBlue});
  MoveTo(dx,0+dy);
  p.x:=FX+dx;
  p.y:=0+dy;
  lineto(p.x,p.y);
  p.x:=fx+dx;
  p.y:=fy+dy;
  lineto(p.x,p.y);
  p.x:=0+dx;
  p.y:=fy+dy;
  lineto(p.x,p.y);
  p.x:=0+dx;
  p.y:=0+dy;
  lineTo(p.x,p.y);
  moveto(fx div 2+dx,0+dy);
  p.x:=fx div 2+dx;
  p.y:=fy+dy;
  lineto(p.x,p.y);
  MoveTo(0+dx,fy div 2+dy);
  p.x:=fx+dx;
  p.y:=(fy div 2+dy);
  lineto(p.x,p.y);
  moveto(fx div 2-5+dx,5+dy);
  p.x:=FX div 2+dx;
  p.y:=(0+dy);
  lineto(p.x,p.y);
  moveTo(FX div 2+5+dx,5+dy);
  p.x:=FX div 2+dx;
  p.y:=(0+dy);
  LineTo(p.x,p.y);
  moveTo(FX-7+dx,FY div 2-5+dy);
  p.x:=FX-2+dx;
  p.y:=(FY div 2+dy);
  LineTo(p.x,p.y);
  moveTo(FX-7+dx,FY div 2+5+dy);
  p.x:=FX-2+dx;
  p.y:=(FY div 2+dy);
  LineTo(p.x,p.y);

  setColor(Col3);
  p.x:=FX div 2+5+dx+(TextWidth('Y')div 2)+2;
  p.y:=0+dy+(TextHeight('Y')div 2)+4;
  OutTextXY(p.x,p.y,'Y');
  p.x:=FX-10+(TextWidth('X')div 2);
  p.y:=FY div 2+5+dx+dy+(TextHeight('X')div 2);
  OutTextXY(p.x,p.y,'X');

  AY:=f.mY;
  PY:=1;
  while AY>10 do begin AY:=round(AY/10);PY:=PY*10;end;
  if AY<3 then AY:=3;

  AX:=f.mX;
  PX:=1;{ॢ: AX - - 㭪⮢; PX - 祭; AX*PX=MaxX}
  while AX>10 do begin AX:=round(AX/10);PX:=PX*10;end;
  if AX<3 then AX:=3;

{=========⪠=========}
  if f.ltype<>ltNone then {⪠}
    SetLineStyle(f.ltype, 0, NormWidth);
  for I := 1 to (AY-1) do begin
    setcolor(Col4{127}{Navy});
    if f.ltype<>ltNone then begin
      moveTo(0+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      LineTo(p.x,p.y);
    end else begin
      moveTo(FX div 2-2+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX div 2+2+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      LineTo(p.x,p.y);
    end;
    setcolor(Col3);
    p.x:=FX div 2+2+dx+(TextWidth(Str2(f.cent.Y+(AY-i)*PY))div 2)+2;
    p.y:=(FY*i) div (AY*2)+dy+1{+(TextHeight(Str2(Y0+(AY-i)*PY))div 2)};
    OutTextXY(p.x,p.y,Str2(f.cent.Y+(AY-i)*PY));
  end;

  for I := AY+1 to (AY*2-1) do begin
    setcolor(Col4);
    if f.ltype<>ltNone then begin
      moveTo(0+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      LineTo(p.x,p.y);
    end else begin
      moveTo(FX div 2-2+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX div 2+2+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      LineTo(p.x,p.y);
    end;
    setcolor(Col3);
    p.x:=FX div 2+2+dx+(TextWidth(Str2(f.cent.Y+(AY-i)*PY))div 2)+2;
    p.y:=(FY*i) div (AY*2)+dy+1{+(TextHeight(Str2(Y0+(AY-i)*PY))div 2)};
    OutTextXY(p.x,p.y,Str2(f.cent.Y+(AY-i)*PY));
  end;


{  Form1.Cursor:=crHourGlass;}
  for I := 1 to (AX-1) do begin
    setcolor(Col4);
    if f.ltype<>ltNone then begin
      moveTo((FX*i) div (AX*2)+dx,0+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY+dy;
      LineTo(p.x,p.y);
    end else begin
      moveTo((FX*i) div (AX*2)+dx,FY div 2-2+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY div 2+2+dy;
      LineTo(p.x,p.y);
    end;
    setcolor(Col3);
    p.x:=(FX*i) div (AX*2)+2+dx;
    p.y:=FY div 2+2+dy+(TextHeight(Str2(f.cent.X+(AX-i)*PX))div 2)+2;
    OutTextXY(p.x,p.y,Str2(f.cent.X+(-AX+i)*PX));
  end;

  for I := AX+1 to (AX*2-1) do begin
    setcolor(Col4);
    if f.ltype<>ltNone then begin
      moveTo((FX*i) div (AX*2)+dx,0+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY+dy;
      LineTo(p.x,p.y);
    end else begin
      moveTo((FX*i) div (AX*2)+dx,FY div 2-2+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY div 2+2+dy;
      LineTo(p.x,p.y);
    end;
    setcolor(Col3);
    p.x:=(FX*i) div (AX*2)+2+dx;
    p.y:=FY div 2+2+dy+(TextHeight(Str2(f.cent.X+(AX-i)*PX))div 2)+2;
    OutTextXY(p.x,p.y,Str2(f.cent.X+(-AX+i)*PX));
  end;


  setcolor(Col3);
  p.x:=FX div 2+1+dx+(TextWidth(Str2(f.cent.X)+','+Str2(f.cent.Y))div 2)+2;
  p.y:=FY div 2+1+dy+(TextHeight(Str2(f.cent.X)+','+Str2(f.cent.Y))div 2)+3;
  OutTextXY(p.x,p.y,Str2(f.cent.X)+','+Str2(f.cent.Y));

{=============ᮢ 䨪===============}
  SetLineStyle(SolidLn, 0, NormWidth);
  setColor(Col5);
  repeat
    t.read(mr,sizeOf(mr));
    case mr.what of
      lgfGo:
        begin
          cx:=fx*mr.x div f.wx;
          cy:=fy*mr.y div f.wy;
          moveTo(cx,cy);
        end;
      lgfDraw:
        begin
          p.x:=fx*mr.x div f.wx;
          p.y:=fy*mr.y div f.wy;
          LineTo(p.x,p.y);
        end;
      lgfPoint:
        begin
          p.x:=fx*mr.x div f.wx;
          p.y:=fy*mr.y div f.wy;
          moveTo(p.x,p.y);
          LineTo(p.x,p.y);
        end;
      lgfFin:
    end;
  until mr.what=lgfFin;
  SetTextJustify(rightText,BottomText);
  SetColor(7);
  OutTextXY(GetMaxX,GetMaxY,'Y='+s);
  readkey;
  CloseGraph;
  writeln('Thank you!');
  writeln('Pasha 1st.');
end.