unit MathLib;
interface
uses Func_Ops,FuncMain,math;
  function ParRound(x:extended):extended; {⥬᪮ 㣫}
  function ParSqrt(x:extended):extended; { ७}
  function ParFrac(x:extended):extended; {஡ }
  function ParSqr(x:extended):extended; {x*x}
  function ParAng(x,y:extended):extended; {㣮 (x,y) c  0x}
  function ParRad(x,y:extended):extended; {.  (0,0)  (x,y)}
  function ParNot(x:extended):extended; {not Trunc(x)}
  function ParRnd:extended; {砩 ⢥ ᫮  0  1}
  function ParLn(x:extended):extended; {ࠫ }
  function ParSc(x:extended):extended; {ᥪ}
  function ParGr2Rad(x:extended):extended; {grad to rad}
  function ParRad2Gr(x:extended):extended; {rad to grad}
  function ParCsc(x:extended):extended; {ᥪ}
  function ParArcSc(x:extended):extended; {ᥪ}
  function ParArcCsc(x:extended):extended; {પᥪ}
  function ParLg(x:extended):extended; { }
  function ParAbs(x:extended):extended; { X}
  function ParExp(x:extended):extended; {e^x}
  function ParSin(x:extended):extended;
  function ParHeav(x:extended):extended; {x>0 -> 1; x<=0 -> 0}
  function ParMax(a,b:extended):extended;
  function ParMin(a,b:extended):extended;
  function ParIDiv(a,b:extended):extended; {"楫᫥" }
  function ParIMod(a,b:extended):extended;{⮪  }
  function ParPh(x:extended):extended; {"䠧"   pi}
  function ParSh(x:extended):extended; {࡮᪨ ᨭ}
  function ParCh(x:extended):extended; {࡮᪨ ᨭ}
  function ParTh(x:extended):extended; {࡮᪨ ⠭}
  function ParCth(x:extended):extended; {࡮᪨ ⠭}
  function ParArSh(x:extended):extended; {࡮᪨ ॠᨭ}
  function ParArCh(x:extended):extended; {࡮᪨ ॠᨭ}
  function ParArTh(x:extended):extended; {࡮᪨ ॠ⠭}
  function ParArCth(x:extended):extended;
          {࡮᪨ ॠ⠭}
  function ParInt(x:extended):extended; {楫  X}
  function ParCos(x:extended):extended;
  function ParTg(x:extended):extended;
  function ParLog(a,b:extended):extended; {Log a  ᭮ b}
  function ParSqrn(x,n:extended):extended; {७ ⥯ b  a}
  function ParCtg(x:extended):extended;
  function ParArcSin(x:extended):extended;
  function ParArcCos(x:extended):extended;
  function ParArcTg(x:extended):extended;
  function ParArcCtg(x:extended):extended;
  function ParPower(a,b:extended):extended; { a  ⥯ b}
  function ParSign(x:extended):extended; {x<0 -> -1, x=0 ->0, x>0 ->1}
  Function ParPi:extended;
  Function ParE:extended;
implementation
uses cfg;
{$F+}
function ParGr2Rad(x:extended):extended;
begin
  ParGr2Rad:=pi*x/180;
end;

function ParRad2Gr(x:extended):extended;
begin
  ParRad2Gr:=180*x/pi;
end;

function ParRad(x,y:extended):extended;
begin
  ParRad:=sqrt(x*x+y*y);
end;

function ParAng(x,y:extended):extended; {㣮 (x,y) c  0x}
begin
  If (abs(x-0.0)<config.delta)and(abs(y-0.0)<config.delta)then
    ParAng:=config.EZero else
  if abs(x-0.0)<config.delta then begin
    ParAng:=pi/2-byte(y<0)*pi;
    IsSolid:=false;
  end else
    if abs(y-0.0)<config.delta then begin
      ParAng:=byte(x<0)*pi;
      IsSolid:=false;
    end else
    begin
      if (x>0)and(y<0) then ParAng:=2*pi+ParArcTg(y/x) else
        if (x>0)and(y>0) then ParAng:=ParArcTg(y/x) else
          if (x<0)and(y>0) then ParAng:=pi+ParArcTg(y/x) else
            {if (x<0)and(y<0) then} ParAng:=pi+ParArcTg(y/x);
    end;
end;

function ParPh(x:extended):extended;
begin
  if abs(x)>6.7e9 then ParPh:=config.EZero else
    ParPh:=ParIMod(x,pi);
end;

function ParIDiv(a,b:extended):extended;
begin
  if (abs(b-0.0)<config.delta)or(abs(a/b)>2.1e9) then ParIDiv:=config.EZero
    else ParIDiv:=ParInt(a/b);
end;

function ParIMod(a,b:extended):extended;
begin
  if (abs(b-0.0)<config.delta)or(abs(a/b)>2.1e9) then ParIMod:=config.EZero
    else ParIMod:=a-b*ParInt(a/b);
end;

function ParMax(a,b:extended):extended;
begin
  ParMax:=RMax(a,b);
{  IsSolid:=false;}
end;

function ParMin(a,b:extended):extended;
begin
  ParMin:=RMin(a,b);
end;

function ParHeav(x:extended):extended;
begin
  ParHeav:=byte(x>0);
  If abs(x-0.0)<config.delta then IsSolid:=false;
end;

function ParRnd:extended;
begin
  ParRnd:=random;
  IsSolid:=config.RndSolid;
end;

function ParSh(x:extended):extended;
begin
  if abs(x)>1.1e4 then ParSh:=config.EZero else
    ParSh:=(exp(x)-exp(-x))/2;
end;

function ParCh(x:extended):extended;
begin
  if abs(x)>1.1e4 then ParCh:=config.EZero else
    ParCh:=(exp(x)+exp(-x))/2;
end;

function ParTh(x:extended):extended;
begin
  if abs(x)>1.1e4 then ParTh:=config.EZero else
    ParTh:=(exp(x)-exp(-x))/(exp(x)+exp(-x));
end;

function ParCth(x:extended):extended;
begin
  If (abs(x-0.0)<config.delta)or(abs(x)>1.1e4) then ParCth:=config.EZero
    else ParCth:=(exp(x)+exp(-x))/(exp(x)-exp(-x));
end;

function ParArSh(x:extended):extended;
begin
  ParArSh:=ln(x+sqrt(x*x+1));
end;

function ParArCh(x:extended):extended;
begin
  If x<1 then ParArCh:=config.EZero
    else ParArCh:=ln(x+sqrt(x*x-1));
end;

function ParArTh(x:extended):extended;
begin{!!!}
  If (abs(x)>(1-config.delta)) then ParArTh:=config.EZero else
    ParArTh:=1/2*ln((1+x)/(1-x));
end;

function ParArCth(x:extended):extended;
begin
  If (abs(x)<1+config.delta) then ParArCth:=config.EZero else
    ParArCth:=1/2*ln((x+1)/(x-1));
end;

function ParSqrn(x,n:extended):extended; {७ ⥯ b  a}
begin
  if (abs(n-0.0)<config.delta) then begin
    ParSqrn:=config.EZero;
    exit;
  end;
  if x>=0 then begin
    ParSqrn:=power(x,1/n);
    exit;
  end;
  if (int(n)=n)and((round(n) and 1)=1) then ParSqrn:=-power(-x,1/n)
    else ParSqrn:=config.EZero;
end;

function ParNot(x:extended):extended;
begin
  if abs(x)>2.1e9 then ParNot:=config.EZero else
    ParNot:=not round(ParInt(x));
end;

function ParSc(x:extended):extended;
begin
  if abs(x)>9.223e18 then ParSc:=config.EZero else begin
    x:=cos(x);
    if (abs(x-0.0)<config.delta) then ParSc:=config.EZero
      else ParSc:=1/x;
  end;
end;

function ParCsc(x:extended):extended;
begin
  if (abs(x)>9.223e18) then ParCsc:=config.EZero else begin
    x:=Sin(x);
    if (abs(x)<config.delta) then ParCsc:=config.EZero
      else ParCsc:=1/x;
  end;
end;

function ParArcSc(x:extended):extended;
begin
  if abs(x)<config.delta then ParArcSc:=config.EZero
    else ParArcSc:=ParArcCos(1/x);
end;

function ParArcCsc(x:extended):extended;
begin
  if abs(x)<config.delta then ParArcCsc:=config.EZero
    else ParArcCsc:=ParArcSin(1/x);
end;

Function ParLog(a,b:extended):extended;
begin
  If (b>config.delta)and(a>config.delta)and(abs(b-1.0)>=config.delta) then
    ParLog:=ln(a)/ln(b) else
      ParLog:=config.EZero;
end;

function ParLn(x:extended):extended;
begin
  if x<config.delta then ParLn:=config.EZero else
    ParLn:=ln(x);
end;

function ParLg(x:extended):extended;
begin
  if x<config.delta then ParLg:=config.EZero else
    ParLg:=ln(x)/ln(10);
end;

function ParFrac(x:extended):extended;
begin
  if (abs(x)>2.1e9)then ParFrac:=config.EZero else
    ParFrac:=Frac(x)+byte(x<0);
  ParInt(x);
end;

function ParExp(x:extended):extended;
begin
  if abs(x)>1.1e4 then ParExp:=config.EZero else
    ParExp:=exp(x);
end;

function ParAbs(x:extended):extended;
begin
  If x<0 then ParAbs:=-x else ParAbs:=x;
end;

function ParInt(x:extended):extended; {楫  X}
var b:extended;
begin
  If (abs(x)>2.1e9) then begin
    ParInt:=config.EZero;
    exit;
  end;
  b:=x-Round(x);
  if abs(b)<config.delta*2 then
    IsSolid:=false;
  if abs(b)<(config.delta) then begin
{    IsSolid:=false;}
    if x>0 then ParInt:=Int(x) else
      begin
        if (b<config.delta)and(b>0) then
          ParInt:=Int(x)-1 else
            ParInt:=Int(x);
      end;
    exit;
  end;

  If (x>0) then
    ParInt:=Int(x) else
      ParInt:=int(x)-1;
end;

Function ParPi:extended;
begin
  ParPi:=pi;
end;

Function ParE:extended;
begin
  ParE:=Exp(1);
end;

Function ParPower(a,b:extended):extended;
begin
  ParPower:=Power(a,b);
end;

function ParArcSin(x:extended):extended;
begin
  if abs(x-1)<config.Delta then{x=1}
    ParArcSin:=pi/2 else
  if abs(x+1)<config.Delta then{x=-1}
    ParArcSin:=-pi/2 else
  if abs(x)>1 then ParArcSin:=config.EZero else
    ParArcSin:=ArcTan(x/sqrt(1-x*x));
end;

function ParArcCos(x:extended):extended;
begin
  if abs(x-0.0)<config.delta then {x=0}
    ParArcCos:=Pi/2 else
  if abs(x-1.0)<config.delta then {x=1}
    ParArcCos:=0 else
  If abs(x)>1 then
    ParArcCos:=config.EZero else
    ParArcCos:=byte(x<0)*pi+ArcTan(sqrt(1-sqr(x))/x);
end;

function ParSin(x:extended):extended;
begin
  if abs(x)>9.223e18 then ParSin:=config.EZero else
    ParSin:=sin(x);
end;

function ParCos(x:extended):extended;
begin
  if abs(x)>9.223e18 then ParCos:=config.EZero else
    ParCos:=cos(x);
end;

function ParRound(x:extended):extended;
begin
  if abs(x)>2.1e9 then begin
    ParRound:=config.EZero;
    exit;
  end;
  if (x+0.5>0)or(x+0.5=int(x+0.5)) then
    ParRound:=int(x+0.5) else
      ParRound:=int(x+0.5)-1;
  if abs(x+0.5-round(x+0.5))<config.delta then IsSolid:=false;
end;

function ParSign(x:extended):Extended;
const WasZero:boolean=false;
begin
  if abs(x-0.0)<config.Delta then begin
    ParSign:=0;
    WasZero:=true;
    IsSolid:=false;
  end else begin
    if x>0 then ParSign:=1 else ParSign:=-1;
{    ParSign:=round(x/abs(x));}
    if WasZero then begin
      IsSolid:=false;
      WasZero:=false;
    end;
  end;
end;

function ParTg(x:extended):extended;
begin
  if (abs(cos(x)-0.0)<config.Delta)or(abs(x)>9.223e18) then ParTg:=config.EZero
    else ParTg:=sin(x)/cos(x);
end;

function ParCtg(x:extended):extended;
begin
  if (abs(sin(x)-0.0)<config.Delta)or(abs(x)>9.223e18) then ParCtg:=config.EZero
    else ParCtg:=cos(x)/sin(x);
end;

function ParArcTg(x:extended):extended;
begin
  ParArcTg:=ArcTan(x);
end;

function ParArcCtg(x:extended):extended;
begin
  if abs(x-0.0)<config.Delta then {}
    ParArcCtg:=config.EZero else
    ParArcCtg:=ArcTan(1/x)+byte(x<0)*pi;
end;

function ParSqrt(x:extended):extended;
begin
  if x>=0 then ParSqrt:=sqrt(x)
    else ParSqrt:=config.EZero;
end;

function ParSqr(x:extended):extended;
begin
  ParSqr:=x*x;
end;

{$F-}
end.