{************************************************}
{   MObj.pas                                     }
{   Graph Vision unit                            }
{   Pavel A. Fomin, Ivanovo,1998                 }
{************************************************}
unit MObj;
{$X+,G+}{,I-,S-,}{$F+,O+}{,D-}

interface
uses Crt,Objects,ExtObj,LowGraph,images,GraMenu,GrApp,EventMan,GraV,colors256,
     mstring,math,dos,gfonts,cfg;

procedure ConvertPixRow16(var Source; Width : word);{assembler}

type

{ BMP file header structure }

  PBitmapFileHeader = ^TBitmapFileHeader;{ .BMP 䠩}
  TBitmapFileHeader = record
    bfType: Word;                         { file type. Must be 'BM' }
    bfSize: Longint;                      { file size }
    bfReserved1: Word;                    { reserved, alwais 0 }
    bfReserved2: Word;
    bfOffBits: Longint;                   { absolute offset to image start }
  end;

  PPCXFileHeader=^TPCXFileHeader;{ .PCX 䠩}
  TPCXFileHeader=record
    ManId:byte;{ﭭ 䫠 10 = ZSoft .PCX}
    Ver:byte;{ଠ  ᨨ:0 =  2.5; 2 =  2.8  ଠ樥
          ; 3 =  2.8  ଠ樨  ;5 =  3.0}
    Enc:byte;{1 = .PCX ஢ 묨 ﬨ}
    Bpp:byte;{Bits per pixel 1   ᫮   ᥫ  ᫮}
    Wnd:TRect;{ ࠦ (Xmin,Ymin)-(Xmax,Ymax) ᥫ ⥫쭮}
    HRes,VRes:word;{ਧ⠫쭮/⨪쭮 ࠧ襭 ᮧ饣 ன⢠}
    ClrMap:array[0..15,1..3]of byte;{ 梥⮢  (. ⥪)}
    Reserv1:byte;
    NPlanes:byte;{ ᫮ 梥⮢ ᫮}
    Bpl:word;{Bytes per Line - ᫮   ப  梥⮢ ᫮ (
      PCX-䠩 ᥣ   )}
    PalInfo:word;{ ஢ : 1 = 梥⭠/୮-,
                                                2 = ࠤ樨 ண}
    Filler:array[0..57]of byte;{ ﬨ   }
  end;
{ information about Windows 3.* DIB }

  PBitmapInfoHeader = ^TBitmapInfoHeader;{ ࠦ  .BMP}
  TBitmapInfoHeader = record
    biSize: Longint;                      { = SizeOf(TBitmapInfoHeader) }
    biWidth: Longint;                     { bitmap width in pixels}
    biHeight: Longint;                    { bitmap height in scan lines }
    biPlanes: Word;                       { number of bit planes; must be 1 }
    biBitCount: Word;                     { bits per pixel; must be 1,4,8 or 24 }
    biCompression: Longint;               { compression type: 0-unpacked;
                                          { 1 - RLE8, 2 - RLE4}
    biSizeImage: Longint;                 { image size in bytes }
    biXPelsPerMeter: Longint;
    biYPelsPerMeter: Longint;
    biClrUsed: Longint;                   { Number of colors in color table }
    biClrImportant: Longint;
  end;

  TRGBQuad = record{1    windows .BMP}
    rgbBlue : Byte;
    rgbGreen : Byte;
    rgbRed : Byte;
    rgbReserved: Byte;
  end;

   TRGBTriple = record{1    os/2 .BMP}
      rgbtBlue: Byte;
      rgbtGreen: Byte;
      rgbtRed: Byte;
   end;

  PBitmapInfo = ^TBitmapInfo;{।   .BMP}
  TBitmapInfo = record
    Header: TBitmapInfoHeader;
    Colors: array[0..0] of TRGBQuad;   {record end;}
  end;

{ information about OS/2 PM DIBs }

  PBitmapCoreHeader = ^TBitmapCoreHeader;{Os/2 .bmp}
  TBitmapCoreHeader = record
    bcSize: Longint;                      { = SizeOf(TBitmapCoreHeader) }
    bcWidth: Word;                        { bitmap width in pixels }
    bcHeight: Word;                       { bitmap height in scan lines }
    bcPlanes: Word;                       { number of bit planes; must be 1 }
    bcBitCount: Word;                     { bits per pixel; must be 1,4,8 or 24 }
  end;

  PBitmapCoreInfo = ^TBitmapCoreInfo;{Os/2 .bmp}
  TBitmapCoreInfo = record
    bmciHeader: TBitmapCoreHeader;
    bmciColors: array[0..0] of TRGBTriple;    {record end;}
  end;

   PMBmpFilter = ^TMBmpFilter;{᪨ 䨫 .bmp (ࠢ ਢ 
        ࣥ :)}
   TMBmpFilter = object(TFilter)
      Header : TBitmapInfoHeader;
      procedure Open(AName : FNameStr); virtual;
      procedure GetSize(var ASize : TPoint); virtual;
      procedure GetHeader; virtual;
      procedure LoadImage(AImage : PImage); virtual;
      procedure Save(AName : FNameStr; AImage : PImage); virtual;
      procedure SaveImage(AImage : PImage); virtual;
   end;

   PLGFHeader=^TLGFHeader;{ .lgf ⨭}
   TLGFHeader=record
     FID:array [0..5] of char;{'LGFv1'}
     cent:TPoint;
     mx,my:longint;
     ltype:byte;
     col1,col2,col3,col4,col5:byte;
     wx,wy:integer;
     skip:word;{offset of image}
     {There can be a comment}
   end;

   PLGFRec=^TLGFRec;{ୠ   .lgf}
   TLGFRec=record
     x,y:integer;
     what:byte;
   end;

   PLGFImage=^TLGFImage; {Linear graph format image}
   TLGFImage=object(TObject)
     fs:PStream;
     qqq:word;
     cent:TPoint;
     mx,my:longint;
     ltype:byte;
     col1,col2,col3,col4,col5:byte;{bcol,lcol,ncol,rcol,gcol}
     wx,wy:integer;
{     num:integer;}
     constructor init(ACent:TPoint;ax,ay:longint;awx,awy:integer;Altype:byte;
       acol1,acol2,acol3,acol4,acol5:byte);
     constructor SInit;{  ன ࠦ, ਬ 
       ᫥饩 㧪 ⨭  䠩}
     destructor done;virtual;
     procedure SaveTo(const FName:string;comment:string);virtual;{Save to file}
     function LoadFrom(const FName:string):string;virtual;{Restore from file}
     procedure draw(WS:PGraphView);virtual;{Paint on the canvas}
     procedure AddPix(OX,OY:integer;What:byte);virtual;{ᮢ 1 }
     procedure zero;virtual;{}
     procedure ReInit(ACent:TPoint;ax,ay:longint;awx,awy:integer;Altype:byte;
       acol1,acol2,acol3,acol4,acol5:byte);virtual;{ २樠}
   end;

   PLGFStub=^TLGFStub; {Linear graph format image}
   TLGFStub=object(TLGFImage){"誠",  nul:  MS-DOS}
     constructor init(ACent:TPoint;ax,ay:longint;awx,awy:integer;Altype:byte;
       acol1,acol2,acol3,acol4,acol5:byte);
     constructor SInit;
     destructor done;virtual;
     procedure SaveTo(const FName:string;comment:string);virtual;
     function LoadFrom(const FName:string):string;virtual;
     procedure draw(WS:PGraphView);virtual;
     procedure AddPix(OX,OY:integer;What:byte);virtual;
     procedure zero;virtual;
     procedure ReInit(ACent:TPoint;ax,ay:longint;awx,awy:integer;Altype:byte;
       acol1,acol2,acol3,acol4,acol5:byte);virtual;
   end;

   PMyStatImg=^TMyStatImg;
   TMyStatImg=object(GraphView)
     stream:PStream;
     Constructor Init(t:TRect;rn:string;res:PResourceFile);
     Constructor LoadBMP(t:TRect;fn:string;col:integer);
     destructor done;virtual;
     procedure store(var s:tstream);
     constructor load(var s:TStream);
     procedure draw;virtual;
   end;

   PGauge = ^TGauge;
   TGauge = object(GraphView)
     max,pos,last: longint;
     constructor Init(var Bounds: TRect);
     procedure Draw; virtual;
     procedure Update;
     procedure Incr(n:longint);
     procedure SetUp(n:longint);
   end;


   PMyBIOSFont=^TMyBIOSFont;{ 8xX  㧪  ⮪ ( ࠭
       )}
   TMyBIOSFont=object(TBIOSFont)
     constructor Load(var s:TStream);
     procedure Store(var s:TStream);
   end;

   PMy8x8BIOSFont=^TMy8x8BIOSFont;
   TMy8x8BIOSFont=object(T8x8BIOSFont)
     constructor Load(var s:TStream);
     procedure Store(var s:TStream);
   end;

   procedure WriteBMP(AImage:PImage;const FName:string);{Img 2 .bmp}
   procedure WriteScrBMP(r:TRect;const FName:string);{࠭ -> windows .BMP}
   procedure WriteScrPCX(r:TRect;const FName:string);{࠭ -> ZSoft's .PCX}
   procedure StoreScrImg(r:TRect;AImage:PImage);{࠭ -> Img}

procedure RegisterMImages;

const

   giOk            =  0;
   giError         = -1;             {generic image import error}
   giIOError       = -2;             { IO error }
   giInvalidFormat = -3;             { invalid format }
   giNoLoadMem     = -4;
   cmNoMenuBar     = 1981;
   cmMenuBar       = 1987;

   lgfGo           = 1;{⢨ .lgf}
   lgfDraw         = 2;
   lgfPoint        = 3;
   lgfFin          = 255;

   lgfID           = 'LGF!V1';{⪠ .lgf}

   ltSolid         = 0;{⨯ }
   ltDot           = 1;
   ltCent          = 2;
   ltDash          = 3;
   ltNone          = 255;

   lgSize          = SizeOf(TLGFRec);

const
                {ॣ ꥪ⮢}
  RMBmpFilter: TStreamRec = (
    ObjType: 12380;{80}
    VmtLink: Ofs(TypeOf(TMBmpFilter)^);
    Load: @TMBmpFilter.Load;
    Store: @TMBmpFilter.Store);

  RMBIOSFont: TStreamRec = (
    ObjType: 12390;{80}
    VmtLink: Ofs(TypeOf(TBIOSFont)^);
    Load: @TMyBIOSFont.Load;
    Store: @TMyBIOSFont.Store);

  RM8x8BIOSFont: TStreamRec = (
    ObjType: 12395;{80}
    VmtLink: Ofs(TypeOf(T8x8BIOSFont)^);
    Load: @TMy8x8BIOSFont.Load;
    Store: @TMy8x8BIOSFont.Store);

  RLGF: TStreamRec = (
    ObjType: 12345;
    VmtLink: Ofs(TypeOf(TLGFImage)^);
    Load: nil;
    Store: nil);

  RMSI: TStreamRec = (
    ObjType: 12354;
    VmtLink: Ofs(TypeOf(TMyStatImg)^);
    Load: @TMyStatImg.Load;
    Store: @TMyStatImg.store);

var
  gauge : PGauge;
 
implementation
uses Graph,Memory,GrDriver;

const
   TStream_Read = VMTHeaderSize + $14;
{   TImage_PutLine = VMTHeaderSize + $08;}

{ TMBMPFilter methods }

constructor TGauge.Init(var Bounds: TRect);
begin
  inherited init(bounds);
  GrowMode:=gfGrowAll;
  max:=0;
  pos:=0;
  last:=0;
end;

procedure TGauge.Draw;
var l:longint;
    r:TRect;
    OldCol:integer;
    p:TPoint;
begin
  GetExtent(r);
  OldCol:=graph.GetColor;
  if max=0 then begin
    SetFillStyle(solidFill,scLightGray);
    bar(r);
    SetColor(OldCol);
    exit;
  end;
  GFonts.SetTextStyle(systemFont,HorizDir,1);
  SetLineStyle(solidLn,0,1);
{  SetFillStyle(SolidFill,5);}
  if config.GraphMode=0 then SetColor(scLightRed);
  r.a.x:=(IMin(length(Str2(pos*100 div max)),3)+1)*8;
  r.b.x:=r.a.x;
  for l:=(length(Str2(pos*100 div max))+1)*8
    to ((pos*size.x) div max) do
  begin
{    if config.GraphMode<>0 then setColor(-((l*16) div size.x)+31);}
    p:=r.b;
    SetCursor(r.a.x,r.a.y);
    setColor(scWhite);
    p.y:=p.y div 3;
    LineTo(p);
    setColor(scBlue);
    p.y:=p.y*2;
    LineTo(p);
    setColor(scRed);
    LineTo(r.b);
{    Bar(r);}
{    line(r);}
    inc(r.a.x);
    inc(r.b.x);
  end;
  GetExtent(r);
  SetColor(scDarkGray);
  SetTextJustify(LeftText,TopText);
  WriteTextXY(r.a,Str2(IMin(pos*100 div max,100))+'%');
  last:=pos;
  SetColor(OldCol);
end;

procedure TGauge.Update;
begin
  if max=0 then exit;
  if ((pos*size.x) div max)<>((last*size.x)div max) then
    DrawView;
end;

procedure TGauge.Incr(n:longint);
begin
  inc(pos,n);
  DrawView;
end;

procedure TGauge.SetUp(n:longint);
begin
  max:=0;
  pos:=0;
  last:=0;
  DrawView;
  max:=n;
end;

procedure TMBmpFilter.Open(AName : FNameStr);{⢮  ࣥ }
var
   FileHeader : TBitmapFileHeader;
begin
   Stream := New(PDosStream,Init(AName,stOpenRead));
   if Stream <> nil then begin
      if Stream^.Status <> stOK then begin
         Dispose(Stream,Done);
         ErrorCode := giIOError;
         Exit;
      end;
      Stream^.Read(FileHeader,SizeOf(TBitmapFileHeader));
      with FileHeader do
      if (bfType <> $4D42) or (bfSize <= bfOffBits) then begin
         Dispose(Stream,Done);
         ErrorCode := giInvalidFormat;
         Exit;
      end;
      GetHeader;
   end;
end;

procedure TMBmpFilter.GetHeader;
var
   CurPos : LongInt;
   Os2Header : TBitmapCoreHeader absolute Header;
begin
   CurPos := Stream^.GetPos;
   Stream^.Read(Header,SizeOf(TBitmapInfoHeader));
   if Header.biSize = SizeOf(TBitmapInfoHeader) then inc(CurPos,Header.biSize)
   else inc(CurPos,Os2Header.bcSize);
   Stream^.Seek(CurPos);
end;

procedure TMBmpFilter.GetSize(var ASize : TPoint);
var
   Os2Header : TBitmapCoreHeader absolute Header;
begin
   if Header.biSize = SizeOf(TBitmapInfoHeader) then begin
      ASize.X := integer(Header.biWidth);
      ASize.Y := integer(Header.biHeight);
   end else begin
      ASize.X := integer(Os2Header.bcWidth);
      ASize.Y := integer(Os2Header.bcHeight);
   end;
end;

{$F+}
procedure ConvertPixRow16(var Source; Width : word);{assembler}
var {८ࠧ Bitmap -> Image}
   i,j,k : word;
   n:byte;
   b1:array[0..7]of byte;
   b2:array[0..3]of byte;
   dest:pointer;
{   buf:pointer;}
begin
  GetMem(dest,width);
  for i:=1 to width do TByteArray(dest^)[i]:=0;
  i:=width div 8+byte(not not boolean(width mod 8));
  for j:=0 to (width div 8)-1+byte(not not boolean(width mod 8))  do begin
{    dec(n,2);}
    for k:=0 to 7 do b1[k]:=TByteArray(source)[j*8+k];
    for k:=0 to 3 do b2[k]:=0;
    for k:=0 to 7 do begin
      b2[0]:=b2[0]or(((b1[k] and 8)shl 4)shr k);
    end;
    for k:=0 to 7 do begin
      b2[1]:=b2[1]or(((b1[k] and 4)shl 5)shr k);
    end;
    for k:=0 to 7 do begin
      b2[2]:=b2[2]or(((b1[k] and 2)shl 6)shr k);
    end;
    for k:=0 to 7 do begin
      b2[3]:=b2[3]or(((b1[k] and 1)shl 7)shr k);
    end;
    for k:=0 to 3 do
      TByteArray(dest^)[k*i+j]:=b2[k];
  end;
  Move(dest^,source,width);
  FreeMem(dest,width);
end;

procedure ConvertPixRow256(var Source,Dest; Width : word; var Palette : TPaletteType); assembler;
var
   i : word;
asm
{ first convert colors }
        push   ds
        les    di,Source        { array of pixel's colors (byte per pixel) }
        mov    cx,Width
        lds    bx,Palette
        add    bx,2
@@2:    mov    al,es:[di]       { load color value }
        xlat                    { convert it to Borland' color set }
        stosb                   { and store }
        loop   @@2
{ copy from source to dest }
        lds    si,Source
        les    di,Dest
        mov    cx,Width
        rep    movsb
        pop    ds
end;
{$f-}

procedure TMBmpFilter.LoadImage(AImage : PImage);{. ࣥ }
var
   Os2Header : TBitmapCoreHeader absolute Header;
   WindowsBMP : boolean;
   Compressed : boolean;
   CurPos,ImageSize : LongInt;
   Colrs,Bits,T,I : word;
   BmpBufSize : word;
   PixelsPerByte : word;
   ImgBuf : pointer;
   BmpBuf : pointer;
   TransmitBuf : pointer;
   ExtraBytes,SkipBytes : word;
   OldDS,BufCount : word;
   Width,Lines : word;
   Palette : TPaletteType;
   PalEntry : TRGBQuad;
   Image : PImage;
   Siz : TPoint;
   S : PStream;
   mc:word;
   mconv: procedure(var Source,Dest; Width : word; var Palette : TPaletteType);

begin
   if LowMemory then begin
      ErrorCode := grNoLoadMem;
      Exit;
   end;
   GetSize(Siz);
   S := Stream;
   CurPos := S^.GetPos;
   WindowsBMP := Header.biSize = SizeOf(TBitmapInfoHeader);
   if WindowsBMP then
   begin   { processing Windows-style bitmap }
      Bits := Header.biBitCount;
      PixelsPerByte := 8 div Bits;
      Compressed := Header.biCompression <> 0;
      ImageSize := Header.biSizeImage;
      If Header.biPlanes<>1then begin
{        Dispose(Stream,Done);}
        ErrorCode:=giInvalidFormat;
        exit;
      end;
      if not Compressed and (ImageSize = 0) then
         ImageSize := (LongInt(Siz.X)+ integer((Siz.X and 1) <> 0)) * Siz.Y div PixelsPerByte;
   end
   else begin { otherwise OS/2-style bitmap }
      Bits := Os2Header.bcBitCount;
      PixelsPerByte := 8 div Bits;
      ImageSize := (LongInt(Siz.X)+ integer((Siz.X and 1) <> 0)) * Siz.Y div PixelsPerByte;
      Compressed := false;
   end;
   { define number of palette entries }
{   if Bits > Planes * BitPerPlane then Exit;}
   Colrs := 1 shl Bits;
   T := Colrs;
   mc:=GetMaxColor+1;
{   if mc=16 then mconv := ConvertPixRow16 else
     mconv:=ConvertPixRow256;}
   if WindowsBMP then begin
      with Header do
      if biClrUsed <> 0 then T := word(biClrUsed);
      for i := 0 to T-1 do begin
         S^.Read(PalEntry,SizeOf(TRGBQuad));
         with PalEntry do
         Palette.Colors[i] := GetNearestColor(mc,rgbRed,rgbGreen,rgbBlue);
      end;
      inc(CurPos,T * SizeOf(TRGBQuad));
   end else begin
      for i := 0 to T-1 do begin
         S^.Read(PalEntry,SizeOf(TRGBTriple));
         with PalEntry do
         Palette.Colors[i] := GetNearestColor(mc,rgbRed,rgbGreen,rgbBlue);
      end;
      inc(CurPos, T * SizeOf(TRGBTriple));
   end;
   Palette.Size := T;
   if ImageSize = 0 then ImageSize := S^.GetSize - CurPos;
   S^.Seek(CurPos);
   ImgBuf := MemAlloc(AImage^.GetBytesPerLine);
   TransmitBuf := MemAlloc(word(Siz.X));
   if MaxAvail >= 64 * 1024 then BmpBufSize := 63 * 1024
   else BmpBufSize := word(MaxAvail);
   if LongInt(BMPBufSize) > ImageSize then BmpBufSize := word(ImageSize);
   GetMem(BMPBuf,BmpBufSize);
   Width := Siz.X;
   Lines := Siz.Y;
   asm
         cmp    byte ptr Compressed,true
         je     @@12
{         jmp    @@12}
{ process uncompressed bitmap }
@@0:     mov    ax,Width
         mul    Bits
         mov    bx,ax
         shr    ax,3
         test   bx,7
         je     @@1
         inc    ax
@@1:     mov    dx,ax {ax - ᫮ ⮢}
         shr    ax,2
         test   dx,3
         je     @@2
         inc    ax
@@2:     shl    ax,2  {ax - ᫮ ⮢,dx ஢ ᫮ ⮢}
         sub    ax,dx
         mov    ExtraBytes,ax           { calculate extra bytes }
         mov    al,byte ptr Bits
         mov    ah,byte ptr PixelsPerByte
         mov    T,ax
{ processing bitmap image }
         xor    ax,ax
         mov    BufCount,ax             { force to read part of image into buf }
         mov    SkipBytes,ax
         mov    OldDS,ds                { save current DS }
{ processing current line }
@@4:     dec    Lines                      { actual line number }
         mov    bx,Width
         lds    si,TransmitBuf {⮢ }
@@5:     call   @@GetByte
         mov    cx,T
{ processing pixels stored in current byte }
@@7:     {xor    ah,ah}
         shl    ah,8
         shl    ax,cl
         mov    ds:[si],ah
         inc    si
         dec    bx                      { all done with current line? }
         jz     @@8                     { yes }
         dec    ch                      { all done with current byte? }
         jnz    @@7                     { no - repeat }
         jmp    @@5                     { yes - get next byte }
{ skip extra bytes if any }
@@8:     mov    cx,ExtraBytes
         or     cx,cx
         je     @@10
         sub    BufCount,cx
         jc     @@9
         add    di,cx
         mov    SkipBytes,0
         jmp    @@10
@@9:     neg    BufCount
         mov    ax,BufCount
         mov    SkipBytes,ax
         mov    BufCount,0
@@10:
         call   @@PutLine
         cmp    Lines,0                { all done? }
         je     @@11                   { yes }
         jmp    @@4                    { go to process next bitmap line }
@@11:    jmp    @@exit

@@GetByte:
         cmp    BufCount,0              { all done with current buffer? }
         ja     @@6                     { no }
         push   bx
         push   ds                      { preserve ds and si }
         push   si
         mov    ds,OldDS
         les    di,BmpBuf               { pointer to input buffer }
         push   es                      { place onto stack as 1st param }
         push   di
         mov    ax,BmpBufSize
         cmp    ImageSize.word[2],0
         jne    @@5_1
         cmp    ImageSize.word[0],ax
         jae    @@5_1
         mov    ax,ImageSize.word[0]
@@5_1:   sub    ImageSize.word[0],ax
         sbb    ImageSize.word[2],0
         push   ax                      { count as 2nd parameter}
         sub    ax,SkipBytes
         mov    BufCount,ax
         les    di,S                    { SELF param for stream }
         push   es
         push   di
         mov    di,es:[di]              { call stream' Read method }
         call   dword ptr [di].TStream_Read
         les    di,BmpBuf
         add    di,SkipBytes
         pop    si
         pop    ds
         pop    bx
@@6:     mov    al,es:[di]              { load byte }
         inc    di
         dec    BufCount
         retn

@@PutLine:
         mov    ds,OldDS
         push   es                      { preserve pointer to current buf }
         push   di
{ convert pixels string to device dependent format }
         les    di,TransmitBuf
         push   es                      { ptr to source buf as 1st param }
         push   di
         les    di,ImgBuf
         push   es                      { ptr to dest buffer as 2nd param }
         push   di
         push   Width                   { image width }
         lea    di,Palette
         push   ss
         push   di
         call   mConv
{         cmp mc,16
         jne @@5_p1
         call ConvertPixRow16
         jmp @@5_p2
@@5_p1:
         call ConvertPixRow256
@@5_p2:}
{ place row into image }
         push    Lines                  { current line number as 1st param }
         push    ImgBuf.word[2]
         push    ImgBuf.word[0]
         les     di,AImage
         push    es
         push    di
         call    TImage.PutLine
{ restorte actual values }
         pop     di                     { restore pointer in bitmap buf }
         pop     es
         retn

{ compressed bitmap }
@@12:    mov    al,byte ptr Bits
         mov    ah,byte ptr PixelsPerByte
         mov    T,ax
{ processing bitmap image }
         xor    ax,ax
         mov    BufCount,ax             { force to read part of image into buf }
         mov    SkipBytes,ax
         mov    OldDS,ds                { save current DS }
@@13:    dec    Lines
         jns    @@13_1
         jmp    @@exit
@@13_1:
         lds    si,TransmitBuf
@@14:    call   @@GetByte
         or     al,al
         jz     @@15                    { escape or absolute mode }
{ encoded mode }
         mov    bx,ax                   { repeat count }
         call   @@GetByte               { get pixel(s) value }
         mov    dl,al
         mov    cx,T
@@14_1:  {xor    ah,ah}
         shl    ah,8
         shl    ax,cl
         mov    ds:[si],ah
         inc    si
         dec    bl
         jz     @@14
         dec    ch
         jnz    @@14_1
         mov    al,dl
         mov    cx,T
         jmp    @@14_1

@@15:    call   @@GetByte
         cmp    al,2
         ja     @@17
{ escape sequence }
@@16:    or     al,al                   { end of line? }
         jnz    @@16_1
         call   @@PutLine
         jmp    @@13
@@16_1:  cmp    al,1                    { end of bitmap? }
         jne    @@16_2
         mov    ds,OldDS
         jmp    @@exit
@@16_2:  { move current position (???) }
         { don't know how process it. Just skip two bytes }
         call   @@GetByte
         call   @@GetByte
         jmp    @@14
{ absolute mode }
@@17:    mov    bx,ax
         mov    cx,T
@@17_1:  call   @@GetByte
@@17_2:  shl    ah,8
         shl    ax,cl
         mov    ds:[si],ah
         inc    si
         dec    bl
         jnz    @@17_4
         test   di,1
         jz     @@17_3
         call   @@GetByte
@@17_3:  jmp    @@14
@@17_4:  dec    ch
         jnz    @@17_2
         mov    cx,T
         jmp    @@17_1
@@exit:
   end;

   { dispose all used buffers }
   FreeMem(BmpBuf,BmpBufSize);
   FreeMem(TransmitBuf,word(Siz.X));
   FreeMem(ImgBuf,AImage^.GetBytesPerLine);
end;

procedure TMBMPFilter.Save(AName : FNameStr; AImage : PImage);
var s:PDosStream;{। }
    FHead:TBitmapFileHeader;
    i,t,j:integer;
    r,g,b:byte;
    p:pointer;
begin
{  t:=GetMaxColor;
  i:=0;
  while t<>0 do begin
    t:=t shr 1;
    inc(i);
  end;}
  s:=new(PDosStream,init(AName,stCreate{,1024}));
  with FHead do begin
    bfType:=$4D42;
    bfSize:=SizeOf(TBitmapFileHeader)+SizeOf(TBitmapInfoHeader)+
    AImage^.size.x*longint(AImage^.size.y)*4;
(*      (1 shl t {bitCount})+{Header.biSizeImage;}
      ((LongInt(AImage^.size.x)+3)div 4)*4 * AImage^.size.y
        div(8 div t{Header.biBitCount});
      {+((Header.biHeight*biWidth)div(8 div Header.biBitCount))};*)
    bfOffBits:=SizeOf(TBitmapFileHeader)+SizeOf(TBitmapInfoHeader)(*+
      (1 shl t{Header.biBitCount})*4;*)
  end;
  s^.write(FHead,sizeOf(FHead));
  with Header do begin
    biSize:=SizeOf(TBitmapInfoHeader);
    biCompression:=0;
    biWidth:=AImage^.size.x;
    biHeight:=AImage^.size.y;
  end;
  s^.write(Header,SizeOf(Header));
  t:=24;{1 shl Header.biBitCount;}
{  for i:=0 to t-1 do begin
    asm
      mov ah,10h
      mov al,15h
      mov bx,i
      int 10h
      mov r,dh;
      mov g,ch;
      mov b,cl;
    end;
    s^.write(r,1);
    s^.write(g,1);
    s^.write(b,1);
    g:=0;
    s^.write(g,1);
  end;}
  getMem(p,AImage^.GetBytesPerLine*4);
  for i:=AImage^.size.y downto 1 do begin
    AImage^.GetLine(i,p^);
    for t:=1 to AImage^.GetBytesPerLine do begin
    j:=TByteArray(p^)[t-1];
      asm
        mov ah,10h
        mov al,15h
        mov bx,j
        int 10h
        mov r,dh;
        mov g,ch;
        mov b,cl;
      end;
      s^.write(r,1);
      s^.write(g,1);
      s^.write(b,1);
      r:=0;
      s^.write(r,1);
    end;
  end;
  dispose(s,done);
end;

procedure TMBmpFilter.SaveImage(AImage : PImage);
begin
end;

procedure WriteBMP(AImage:PImage;const FName:string);
var s:PBufStream;
    FHead:TBitmapFileHeader;
    IHead:TBitmapInfoHeader;
    r,g,b:byte;
    i,j,t:integer;
    curPos:longInt;
    x,y:word;
    p:pointer;
    bits:byte;
    bytes:byte;
begin
  x:=AImage^.size.x;
  y:=AImage^.size.y;
  new(s,init(FName,stCreate,1024));
  t:=GetMaxColor;
  bits:=0;
  while t<>0 do begin
    t:=t shr 1;
    inc(bits);
  end;
  t:=GetMaxColor;
  bytes:=8 div bits;
  with FHead do begin
    bfType:=$4D42;
    bfSize:=(((x div bytes)+3)div 4)*4*y+sizeOf(FHead)
      +sizeOf(IHead)+4*(t+1);
    bfReserved1:=0;
    bfReserved2:=0;
    bfOffbits:=sizeOf(FHead)+sizeOf(IHead)+4*(t+1);
  end;
  s^.write(FHead,sizeOf(FHead));
  with IHead do begin
    biSize:=SizeOf(IHead);
    biWidth:=x;
    biHeight:=y;
    biPlanes:=1;
    biBitCount:=Bits;
    biCompression:=0;
    biSizeImage:=(((x div (bytes))+3)div 4)*4*longInt(y);
    biXPelsPerMeter:=0;
    biYPelsPerMeter:=0;
    biClrUsed:=t+1;
    biClrImportant:=t+1;
  end;
  s^.write(IHead,sizeOf(IHead));
  for i:=0 to t do begin{ ⥬ }
    asm
      mov ah,10h
      mov al,15h
      mov bx,i
      int 10h
      mov r,dh;
      mov g,ch;
      mov b,cl;
    end;
    s^.write(r,1);
    s^.write(g,1);
    s^.write(b,1);
    g:=0;
    s^.write(g,1);
  end;
{  j:=GetMaxColor;
  asm
    mov ax,1017h
    xor bx,bx
    mov cx,j
    inc j
    push es
    int 10h
    mov word ptr p[0],dx
    mov word ptr p[2],es
  end;}
  r:=0;
  b:=0;
  g:=0;
  CurPos:=AImage^.Data^.GetPos;
  for i:=AImage^.size.y downto 1 do begin{ }
    AImage^.Data^.Seek((x div bytes)*(i-1));
    s^.CopyFrom(AImage^.Data^,x div bytes);
    if (x div bytes) and 3 <>0 then begin
      s^.write(r,(x div bytes) and 3);
    end;
  end;
  AImage^.Data^.seek(CurPos);
  dispose(s,done);
end;

procedure WriteScrBMP(r:TRect;const FName:string);{. ᠭ .BMP}
var s:PBufStream;
    FHead:TBitmapFileHeader;
    IHead:TBitmapInfoHeader;
    r1,g1,b1:byte;
    i,j,t:integer;
    x,y:word;
    p:pointer;
    bits:byte;
    bytes:byte;
    vp:ViewPortType;
begin
  GetViewSettings(vp);
  SetViewPort(0,0,GetMaxX,GetMaxY,false);
  x:=r.b.x-r.a.x+1;
  y:=r.b.y-r.a.y+1;
  new(s,init(FName,stCreate,1024));
  t:=GetMaxColor;
  bits:=0;
  while t<>0 do begin
    t:=t shr 1;
    inc(bits);
  end;
  t:=GetMaxColor;
  bytes:=8 div bits;
  with FHead do begin
    bfType:=$4D42;
    bfSize:=(((longInt(x){ div bytes})+3)div 4)*4*y+sizeOf(FHead)
      +sizeOf(IHead)+longint(4)*(t+1);
    bfReserved1:=0;
    bfReserved2:=0;
    bfOffbits:=sizeOf(FHead)+sizeOf(IHead)+4*(t+1);
  end;
  s^.write(FHead,sizeOf(FHead));
  with IHead do begin
    biSize:=SizeOf(IHead);
    biWidth:=x;
    biHeight:=y;
    biPlanes:=1;
    biBitCount:=8{Bits};
    biCompression:=0;
    biSizeImage:=(((x {div (bytes)})+3)div 4)*4*longInt(y);
    biXPelsPerMeter:=0;
    biYPelsPerMeter:=0;
    biClrUsed:=t+1;
    biClrImportant:=t+1;
  end;
  s^.write(IHead,sizeOf(IHead));
{  for i:=0 to t do begin
    asm
      mov ah,10h
      mov al,15h
      mov bx,i
      int 10h
      mov r1,dh;
      mov g1,ch;
      mov b1,cl;
    end;
    s^.write(r1,1);
    s^.write(g1,1);
    s^.write(b1,1);
    g1:=0;
    s^.write(g1,1);
  end;}
  GetMem(p,3*(t+1));
  asm{ ⥬ }
    mov ax,1017h
    xor bx,bx
    mov cx,t
    inc cx
    push es
    mov dx,word ptr p[0]
    mov es,word ptr p[2]
    int 10h
    pop es
  end;
  TByteArray(p^)[15*3]:=$3f; {쪨 fix}
  TByteArray(p^)[15*3+1]:=$3f;
  TByteArray(p^)[15*3+2]:=$3f;
  r1:=0;
  b1:=0;
  g1:=0;
  for i:=0 to t do begin
    TByteArray(p^)[i*3]:=lo(word(TByteArray(p^)[i*3]*$FF div $3f));
    TByteArray(p^)[i*3+1]:=lo(word(TByteArray(p^)[i*3+1]*$FF div $3f));
    TByteArray(p^)[i*3+2]:=lo(word(TByteArray(p^)[i*3+2]*$FF div $3f));
    s^.write(TByteArray(p^)[i*3+2],1);
    s^.write(TByteArray(p^)[i*3+1],1);
    s^.write(TByteArray(p^)[i*3],1);
    s^.write(g1,1);
  end;
  freeMem(p,3*(t+1));
  for i:=r.b.y downto r.a.y do begin{   win .BMP N/C}
    for j:=r.a.x to r.b.x do begin
      r1:=GetPixel(j,i);
      s^.write(r1,1);
    end;
    if (x {div bytes}) and 3 <>0 then begin
      s^.write(r,4-((x {div bytes}) and 3));
    end;
  end;
{  AImage^.Data^.seek(CurPos);}
  dispose(s,done);
  SetViewPort(vp.x1,vp.y1,vp.x2,vp.y2,vp.clip);
end;

procedure WriteScrPCX(r:TRect;const FName:string);
var s:PBufStream;
    FHead:TPCXFileHeader;
{    IHead:TBitmapInfoHeader;}
    r1,g1,b1,q1:byte;
    i,j,t:integer;
    x,y:word;
    p:pointer;
    bits:byte;
    bytes:byte;
    vp:ViewPortType;
begin
  GetViewSettings(vp);
  SetViewPort(0,0,GetMaxX,GetMaxY,false);
  fhead.wnd:=r;
  x:=r.b.x-r.a.x+1;
  y:=r.b.y-r.a.y+1;
  new(s,init(FName,stCreate,1024));
  t:=GetMaxColor;
  bits:=0;
  while t<>0 do begin
    t:=t shr 1;
    inc(bits);
  end;
  t:=GetMaxColor;
  bytes:=8 div bits;
  with FHead do begin
    ManId:=10;
    Ver:=5;
    Enc:=1;
    Bpp:=8;
    hres:=GetMaxX+1;
    vres:=GetMaxY+1;
    NPlanes:=1;
    PalInfo:=1;
    Bpl:=x+(x and 1);
  end;
  FillChar(fhead.filler,58,0);
{  GetMem(p,3*(t+1));}
  asm
    mov ax,1017h
    xor bx,bx
    mov cx,15
    inc cx
    push es
{    mov dx,offset fhead.ClrMap}
    lea dx,fhead.clrMap
    push ss
    pop es
{    mov es,segment fhead.ClrMap}
    int 10h
    pop es
  end;
  r1:=0;
  b1:=0;
  g1:=0;
  for i:=0 to 15 do begin
    fhead.clrMap[i,1]:=lo(word(fhead.clrMap[i,1]*$FF) div $3f);
    fhead.clrMap[i,2]:=lo(word(fhead.clrMap[i,2]*$FF) div $3f);
    fhead.clrMap[i,3]:=lo(word(fhead.clrMap[i,3]*$FF) div $3f);
  end;
{    s^.write(TByteArray(p^)[i*3+2],1);
    s^.write(TByteArray(p^)[i*3+1],1);
    s^.write(TByteArray(p^)[i*3],1);
    s^.write(g1,1);
  end;
  freeMem(p,3*(t+1));}
  s^.write(FHead,sizeOf(FHead));
  b1:=0;
  for i:=r.a.y to r.b.y do begin{  .pcx  ᦠ⨥ RLE}
    for j:=r.a.x to r.b.x do
    begin
      if b1=0 then begin
        r1:=GetPixel(j,i);
        b1:=1;
      end else begin
        g1:=GetPixel(j,i);
        if (g1=r1)and(b1<63) then inc(b1) else
        begin
          if (b1>1)or((r1 and (128+64))=(128+64)) then
          begin
            q1:=128+64+b1;
            s^.write(q1,1);
            s^.write(r1,1);
            r1:=g1;
            b1:=1;
          end else begin
            s^.write(r1,1);
            r1:=g1;
            b1:=1;
          end;
        end;
      end;
    end;
    if b1=0 then else
    if (b1=1)and((r1 and (128+64))<>(128+64)) then begin
      s^.write(r1,1);
    end else begin
      q1:=128+64+b1;
      s^.write(q1,1);
      s^.write(r1,1);
      r1:=g1;
      b1:=1;
    end;
    b1:=0;
    if odd(x) then
      s^.write(r1,1);
  end;
  GetMem(p,3*256);
  asm
    mov ax,1017h
    xor bx,bx
    mov cx,255
    inc cx
    push es
    les dx,p
    int 10h
    pop es
  end;
  q1:=12;
  s^.write(q1,1);
  TByteArray(p^)[15*3]:=$3f;
  TByteArray(p^)[15*3+1]:=$3f;
  TByteArray(p^)[15*3+2]:=$3f;
  for i:=0 to 255 do begin
    TByteArray(p^)[i]:=lo(word(TByteArray(p^)[i]*$FF) div $3f);
  end;
  s^.write(p^,3*256);
  freeMem(p,3*(t+1));
{  AImage^.Data^.seek(CurPos);}
  dispose(s,done);
  SetViewPort(vp.x1,vp.y1,vp.x2,vp.y2,vp.clip);
end;

procedure StoreScrImg(r:TRect;AImage:PImage);
begin
end;

procedure RegisterMImages;
begin
  RegisterType(RMBmpFilter);
{  RegisterType(RBgiFilter);
  RegisterType(RImage);}
end;

constructor TLGFImage.init(ACent:TPoint;ax,ay:longint;awx,awy:integer;
              Altype:byte;acol1,acol2,acol3,acol4,acol5:byte);
var s:string;
    i:integer;
    found:boolean;

function exist(const s:string):boolean;{஢ઠ ⢮ 䠩}
var f:file;
begin
  exist:=false;
  assign(f,s);
  {$i-}
  reset(f);
  {$i+}
  if IOResult=0 then begin
    close(f);
    exist:=true;
  end;
end;

var r:TLGFRec;
begin
  inherited init;
  cent:=ACent;
  mx:=ax;
  my:=ay;
  wx:=awx;
  wy:=awy;
  col1:=acol1;
  col2:=acol2;
  col3:=acol3;
  col4:=acol4;
  col5:=acol5;
  ltype:=altype;
  fs:=new(PXMSStream,init(5*1024));{⪠ ࠧ   XMS}
  if fs^.Status<>stOk then begin
    dispose(PXMSStream(fs),done);
    new(PEMSStream(fs),init(5*1024,5*32*1024));{⪠ ࠧ  EMS}
    if fs^.Status<>stOk then begin
      dispose(PEMSStream(fs),done);
      found:=false;
      if DiskFree(0)>=500000 then
      for i:=0 to 99 do begin
        str(i,s);
        qqq:=i;
        s:='lgftmp'+s+'.$$$';
        if not exist(s) then begin
          found:=true;
          break;
        end;
      end;
      if found then begin
        new(PBufStream(fs),init(s,stCreate,8192));{⪠ ࠧ  䠩}
      end else new(PMemoryStream(fs),init(5*2048,2048));
                        {⪠ ࠧ  Conventional Memory}
    end;
  end;
  r.what:=lgfFin;
  fs^.write(r,SizeOf(r));
end;

constructor TLGFImage.SInit;
var s:string;
    i:integer;
    found:boolean;

function exist(const s:string):boolean;
var f:file;
begin
  exist:=false;
  assign(f,s);
  {$i-}
  reset(f);
  {$i+}
  if IOResult=0 then begin
    close(f);
    exist:=true;
  end;
end;

var r:TLGFRec;
begin
  inherited init;
  fs:=new(PXMSStream,init(5*1024));
  if fs^.Status<>stOk then begin
    dispose(PXMSStream(fs),done);
    new(PEMSStream(fs),init(5*1024,5*32*1024));
    if fs^.Status<>stOk then begin
      dispose(PEMSStream(fs),done);
      found:=false;
      if DiskFree(0)>=500000 then
      for i:=0 to 99 do begin
        str(i,s);
        qqq:=i;
        s:='lgftmp'+s+'.$$$';
        if not exist(s) then begin
          found:=true;
          break;
        end;
      end;
      if found then begin
        new(PBufStream(fs),init(s,stCreate,8192));
      end else new(PMemoryStream(fs),init(5*2048,2048));
    end;
  end;
  r.what:=lgfFin;
  fs^.write(r,SizeOf(r));
end;

procedure TLGFImage.ReInit(ACent:TPoint;ax,ay:longint;awx,awy:integer;
              Altype:byte;acol1,acol2,acol3,acol4,acol5:byte);
var r:TLGFRec;
begin
  cent:=ACent;
  mx:=ax;
  my:=ay;
  wx:=awx;
  wy:=awy;
  col1:=acol1;
  col2:=acol2;
  col3:=acol3;
  col4:=acol4;
  col5:=acol5;
  ltype:=altype;
  fs^.seek(0);
  fs^.truncate;
  r.what:=lgfFin;
  fs^.write(r,SizeOf(r));
end;

destructor TLGFImage.done;
var a:file;
    b:boolean;
    s:string;
begin
  b:=false;
  if typeOf(fs^)=typeOf(TBufStream) then begin{㤠 ᢠ-䠩}
    str(qqq,s);
    s:='lgftmp'+s+'.$$$';
    assign(a,s);
    b:=true;
  end;
  dispose(fs,done);
  if b then erase(a);
  inherited done;
end;

procedure TLGFImage.SaveTo(const FName:string;comment:string);
var f:TBufStream;
    r:TLGFRec;
    h:TLGFHeader;
begin
  f.init(fname,stCreate,8192);
  h.FID:=lgfID;
  h.cent:=cent;
  h.ltype:=ltype;
  h.mx:=mx;
  h.my:=my;
  h.wx:=wx;
  h.wy:=wy;
  h.col1:=col1;
  h.col2:=col2;
  h.col3:=col3;
  h.col4:=col4;
  h.col5:=col5;
  h.skip:=length(comment);
  f.write(h,SizeOf(h));
  if length(comment)<>0 then f.write(comment[1],length(comment));
  fs^.seek(0);
  repeat
    fs^.read(r,sizeOf(r));
    f.write(r,sizeOf(r));
  until r.what=lgfFin;
  f.done;
end;

function TLGFImage.LoadFrom(const FName:string):string;
var f:TBufStream;
    r:TLGFRec;
    h:TLGFHeader;
    s:string;
begin
  f.init(fname,stOpenRead,8192);
  f.read(h,sizeOf(h));
  if lgfID<>h.FID then begin
    f.done;
    exit;
  end;
  fs^.seek(0);{१ ᠭ}
  cent:=h.cent;
  ltype:=h.ltype;
  mx:=h.mx;
  my:=h.my;
  wx:=h.wx;
  wy:=h.wy;
  col1:=h.col1;
  col2:=h.col2;
  col3:=h.col3;
  col4:=h.col4;
  col5:=h.col5;
  if h.skip<>0 then f.read(s[1],h.skip);
  s[0]:=char(h.skip);
  loadFrom:=s;
  repeat{㧪 ࠦ}
    f.read(r,sizeOf(r));
    fs^.write(r,sizeOf(r));
  until r.what=lgfFin;
  f.done;
end;

procedure TLGFImage.draw(WS:PGraphView);
var AY,AX,PX,PY:integer;x,x1,y,y1:extended;s:string;
   cx,cy:longint;
   i:longint;
   fx,fy:longint;
   r:trect;
   p:TPoint;
   mr:TLGFRec;

const dx=0;
      dy=0;

begin
  ws^.GetExtent(R);
  fx:=r.b.x-r.a.x-1{-dx};
  fy:=r.b.y-r.a.y-1{-dy};
  SetWriteMode(NormalPut);
  SetTextJustify(CenterText, CenterText);
  setBkColor(scBlack{GCol});
  setFillStyle(SolidFill,col1);
  R.Assign(dx,dy,fx+2*dx,fY+2*dy);
  ws^.bar(r);
  SetLineStyle(SolidLn,0,1);

  {==============+==============}
  setColor(Col2{scBlue});
  ws^.SetCursor(dx,0+dy);
  p.x:=FX+dx;
  p.y:=0+dy;
  ws^.lineto(p);
  p.x:=fx+dx;
  p.y:=fy+dy;
  ws^.lineto(p);
  p.x:=0+dx;
  p.y:=fy+dy;
  ws^.lineto(p);
  p.x:=0+dx;
  p.y:=0+dy;
  ws^.lineTo(p);
  ws^.SetCursor(fx div 2+dx,0+dy);
  p.x:=fx div 2+dx;
  p.y:=fy+dy;
  ws^.lineto(p);
  ws^.SetCursor(0+dx,fy div 2+dy);
  p.x:=fx+dx;
  p.y:=(fy div 2+dy);
  ws^.lineto(p);
  ws^.SetCursor(fx div 2-5+dx,5+dy);
  p.x:=FX div 2+dx;
  p.y:=(0+dy);
  ws^.lineto(p);
  ws^.SetCursor(FX div 2+5+dx,5+dy);
  p.x:=FX div 2+dx;
  p.y:=(0+dy);
  ws^.lineto(p);
  ws^.SetCursor(FX-7+dx,FY div 2-5+dy);
  p.x:=FX-2+dx;
  p.y:=(FY div 2+dy);
  ws^.lineto(p);
  ws^.SetCursor(FX-7+dx,FY div 2+5+dy);
  p.x:=FX-2+dx;
  p.y:=(FY div 2+dy);
  ws^.lineto(p);

  setColor(Col3);
  p.x:=FX div 2+5+dx+(TextWidth('Y')div 2)+2;
  p.y:=0+dy+(TextHeight('Y')div 2)+4;
  ws^.WriteTextXY(p,'Y');
  p.x:=FX-10+(TextWidth('X')div 2);
  p.y:=FY div 2+5+dx+dy+(TextHeight('X')div 2);
  ws^.WriteTextXY(p,'X');

  AY:=mY;
  PY:=1;
  while AY>10 do begin AY:=round(AY/10);PY:=PY*10;end;
  if AY<3 then AY:=3;

  AX:=mX;
  PX:=1;{ॢ: AX - - 㭪⮢; PX - 祭; AX*PX=MaxX}
  while AX>10 do begin AX:=round(AX/10);PX:=PX*10;end;
  if AX<3 then AX:=3;

{=========⪠=========}
  if ltype<>ltNone then {⪠}
    SetLineStyle(ltype, 0, NormWidth);
  for I := 1 to (AY-1) do begin
    setcolor(Col4{127}{Navy});
    if ltype<>ltNone then begin
      ws^.SetCursor(0+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      ws^.lineTo(p);
    end else begin
      ws^.SetCursor(FX div 2-2+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX div 2+2+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      ws^.lineTo(p);
    end;
    setcolor(Col3);
    p.x:=FX div 2+2+dx+(TextWidth(Str2(cent.Y+(AY-i)*PY))div 2)+2;
    p.y:=(FY*i) div (AY*2)+dy+1{+(TextHeight(Str2(Y0+(AY-i)*PY))div 2)};
    ws^.WriteTextXY(p,Str2(cent.Y+(AY-i)*PY));
  end;

  for I := AY+1 to (AY*2-1) do begin
    setcolor(Col4);
    if ltype<>ltNone then begin
      ws^.SetCursor(0+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      ws^.lineTo(p);
    end else begin
      ws^.SetCursor(FX div 2-2+dx,(FY*i) div (AY*2)+dy);
      p.x:=FX div 2+2+dx;
      p.y:=(FY*i) div (AY*2)+dy;
      ws^.lineTo(p);
    end;
    setcolor(Col3);
    p.x:=FX div 2+2+dx+(TextWidth(Str2(cent.Y+(AY-i)*PY))div 2)+2;
    p.y:=(FY*i) div (AY*2)+dy+1{+(TextHeight(Str2(Y0+(AY-i)*PY))div 2)};
    ws^.writeTextXY(p,Str2(cent.Y+(AY-i)*PY));
  end;


{  Form1.Cursor:=crHourGlass;}
  for I := 1 to (AX-1) do begin
    setcolor(Col4);
    if ltype<>ltNone then begin
      ws^.SetCursor((FX*i) div (AX*2)+dx,0+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY+dy;
      ws^.lineTo(p);
    end else begin
      ws^.SetCursor((FX*i) div (AX*2)+dx,FY div 2-2+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY div 2+2+dy;
      ws^.lineTo(p);
    end;
    setcolor(Col3);
    p.x:=(FX*i) div (AX*2)+2+dx;
    p.y:=FY div 2+2+dy+(TextHeight(Str2(cent.X+(AX-i)*PX))div 2)+2;
    ws^.WriteTextXY(p,Str2(cent.X+(-AX+i)*PX));
  end;

  for I := AX+1 to (AX*2-1) do begin
    setcolor(Col4);
    if ltype<>ltNone then begin
      ws^.SetCursor((FX*i) div (AX*2)+dx,0+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY+dy;
      ws^.lineTo(p);
    end else begin
      ws^.SetCursor((FX*i) div (AX*2)+dx,FY div 2-2+dy);
      p.x:=(FX*i) div (AX*2)+dx;
      p.y:=FY div 2+2+dy;
      ws^.lineTo(p);
    end;
    setcolor(Col3);
    p.x:=(FX*i) div (AX*2)+2+dx;
    p.y:=FY div 2+2+dy+(TextHeight(Str2(cent.X+(AX-i)*PX))div 2)+2;
    ws^.WriteTextXY(p,Str2(cent.X+(-AX+i)*PX));
  end;


  setcolor(Col3);
  p.x:=FX div 2+1+dx+(TextWidth(Str2(cent.X)+','+Str2(cent.Y))div 2)+2;
  p.y:=FY div 2+1+dy+(TextHeight(Str2(cent.X)+','+Str2(cent.Y))div 2)+3;
  ws^.WriteTextXY(p,Str2(cent.X)+','+Str2(cent.Y));

{=============ᮢ 䨪===============}
  fs^.seek(0);
  SetLineStyle(SolidLn, 0, NormWidth);
  setColor(Col5);
  repeat
    fs^.read(mr,sizeOf(mr));
    case mr.what of
      lgfGo:
        begin
          cx:=fx*mr.x div wx;
          cy:=fy*mr.y div wy;
          ws^.SetCursor(cx,cy);
        end;
      lgfDraw:
        begin
          p.x:=fx*mr.x div wx;
          p.y:=fy*mr.y div wy;
          ws^.LineTo(p);
        end;
      lgfPoint:
        begin
          p.x:=fx*mr.x div wx;
          p.y:=fy*mr.y div wy;
          ws^.SetCursor(p.x,p.y);
          ws^.LineTo(p);
        end;
      lgfFin:
    end;
  until mr.what=lgfFin;
end;

procedure TLGFImage.Zero;
var r:TLGFRec;
begin
  fs^.seek(0);
  r.what:=lgfFin;
  fs^.write(r,sizeOf(r));
end;

procedure TLGFImage.AddPix(OX,OY:integer;What:byte);
var r,r1,r2:TLGFRec;

function cmpr(const r,r1:TLGFRec):boolean;assembler;{ࠢ 2 ᥩ}
asm
  cld
  push ds
  lds si,r
  les di,r1
  mov cx,lgSize
  xor ax,ax
  repe cmpsb
  jne @@1
  inc ax
@@1:
  pop ds
end;

function btw(x1,x2,x3:longint):boolean;
begin
  if ((x1<=x2)and(x2<=x3))or((x3<=x2)and(x2<=x1)) then btw:=true else
    btw:=false;
end;

begin
  if What=lgfFin then exit; { 䨪?}
  if fs^.GetPos<=1*SizeOf(TLGFRec) then begin{ 窨?}
    r.x:=ox;
    r.y:=oy;
    r.what:=what;
    fs^.seek(0);
    fs^.write(r,sizeOf(r));
    r.what:=lgfFin;
    fs^.write(r,sizeOf(r));
  end else begin
    fs^.seek(fs^.GetPos-2*SizeOf(TLGFRec));
    fs^.read(r,SizeOf(r));
    r1.x:=ox;
    r1.y:=oy;
    r1.what:=what;
    if cmpr(r,r1) then fs^.seek(fs^.GetPos+SizeOf(TLGFRec)) else
    if (r1.x=r.x)and(r1.y=r.y)and((r1.what=lgfGo)or(r1.what=lgfPoint))
        and((r.what=lgfDraw)or(r.what=lgfPoint))
      then fs^.seek(fs^.GetPos+SizeOf(TLGFRec)) else
    if (r.what=lgfGo)and(what=lgfGo) then begin
      r.y:=oy;
      fs^.seek(fs^.GetPos-1*SizeOf(TLGFRec));
      fs^.write(r1,sizeOf(r1));
      fs^.seek(fs^.GetPos+1*SizeOf(TLGFRec));
    end else if (r.x=ox)and(r.what=lgfDraw)and((what=lgfDraw)or(what=lgfDraw))
      and(fs^.GetPos>1*SizeOf(TLGFRec))then begin
        fs^.seek(fs^.GetPos-2*SizeOf(TLGFRec));
        fs^.read(r2,lgSize);
        if (r2.x=r.x)and(btw(r.y,r1.y,r2.y)) then begin
          fs^.write(r1,lgSize);
          fs^.seek(fs^.getPos+1*lgSize);
        end else begin
          fs^.seek(fs^.getPos+1*lgSize);
          fs^.write(r1,sizeOf(r1));
          r.what:=lgfFin;
          fs^.write(r,sizeOf(r));
        end;
    end else begin
      fs^.write(r1,sizeOf(r1));
      r.what:=lgfFin;
      fs^.write(r,sizeOf(r));
    end;
  end;
end;

constructor TLGFStub.init(ACent:TPoint;ax,ay:longint;awx,awy:integer;
              Altype:byte;acol1,acol2,acol3,acol4,acol5:byte);
begin
end;

constructor TLGFStub.SInit;
begin
end;

procedure TLGFStub.ReInit(ACent:TPoint;ax,ay:longint;awx,awy:integer;
              Altype:byte;acol1,acol2,acol3,acol4,acol5:byte);
begin
end;

destructor TLGFStub.done;
begin
end;

procedure TLGFStub.SaveTo(const FName:string;comment:string);
begin
end;

function TLGFStub.LoadFrom(const FName:string):string;
begin
end;

procedure TLGFStub.draw(WS:PGraphView);
begin
end;

procedure TLGFStub.Zero;
begin
end;

procedure TLGFStub.AddPix(OX,OY:integer;What:byte);
begin
end;


Constructor TMyStatImg.Init(t:TRect;rn:string;res:PResourceFile);
var p:pMyStatImg;
begin
  inherited init(t);
  PObject(p):=res^.get(rn);
{  new(PMemoryStream(stream),init(8192,8192));}
  stream:=p^.stream;
{  p^.stream^.seek(0);
  stream^.copyFrom(p^.stream^,p^.stream^.GetSize);
  dispose();}
  dispose(p);
end;

Constructor TMyStatImg.LoadBMP(t:trect;fn:string;col:integer);
var p:PBufStream;
   sz:longint;
  x,y:longint;
   pe:TRGBQuad;
   pl:TPaletteType;
    i:integer;
  b,c:byte;
    s:tpoint;
   st:pMemoryStream;
begin
  inherited init(t);
  new(P,init(fn,stOpen,1024));
  new(PMemoryStream(stream),init(1024,1024));
  new(st,init(P^.GetSize-14+4,1024));
  with p^ do begin
    seek(14);
    read(sz,4);
    read(x,4);
    read(y,4);
    s.x:=x;
    s.y:=y;
    st^.write(s,4);
    st^.write(x,x*y);
    seek(sizeOf(TBitmapFileHeader)+sizeOf(TBitmapInfoHeader));
    for pl.size:=0 to 255 do begin
      read(pe,4);
      pl.colors[pl.size]:=GetNearestColor(col,pe.rgbRed,pe.rgbGreen,pe.rgbBlue);
    end;
    for y:=s.y downto 1 do begin
      st^.seek(4+(y-1)*s.x);
      for x:=1 to s.x do begin
        read(i,1);
        st^.write(pl.colors[lo(i)],1);
      end;
      if (x mod 4)<>0 then read(i,4-(x mod 4));
    end;
  end;
  stream^.seek(4);
  stream^.write(s,4);
  st^.seek(4);
{  st^.read(i,1);
  b:=lo(i);}
  for y:=1 to s.y do begin
    c:=0;
    for x:=1 to s.x do begin
      st^.read(i,1);
{      c:=1;
      stream^.write(c,1);
      stream^.write(i,1);}
      if c=0 then begin
        b:=lo(i);
        inc(c);
        continue;
      end;
      if (lo(i)<>b)or(c=250) then begin
        stream^.write(c,1);
        stream^.write(b,1);
        c:=1;b:=lo(i);
      end else begin
{        if c=250 then begin
          stream^.write(c,1);
          stream^.write(b,1);
          c:=0;
        end;}
        inc(c);
      end;
    end;
    if c<>0 then begin
      stream^.write(c,1);
      stream^.write(b,1);
    end;
  end;
  stream^.seek(0);
  sz:=stream^.GetSize;
  stream^.write(sz,4);
  dispose(p,done);
  dispose(st,done);
end;

destructor TMyStatImg.done;
begin
  dispose(stream,done);
  inherited done;
end;

procedure TMyStatImg.store(var s:tstream);
{var spos:longint;}
begin
{  spos:=stream^.GetPos;}
  stream^.seek(0);
{  s.write(size,4);}
  s.CopyFrom(stream^,stream^.getSize);
end;

constructor TMyStatImg.load(var s:TStream);
var l:longint;
begin
  new(PMemoryStream(stream),init(1024,1024));
{  s.seek(0);}
  s.read(l,4);
  s.seek(s.GetPos-4);
{  s.seek(0);}
{  l:=s.getSize;}
  stream^.copyFrom(s,l);
{  PObject(stream):=s.get;}
end;

procedure TMyStatImg.draw;
var
z,x,y,l:longint;
  b,c:byte;
 s1,s:tpoint;
    p:Pointer;

begin
  with stream^ do begin
    seek(0);
    read(x,4);
    read(s,4);
    SetWriteMode(NormalPut);
    SetLineStyle(0,0,1);
{    GetMem(p,4+s.x*s.y);}
    TWordArray(p^)[0]:=s.x;
    TWordArray(p^)[1]:=s.y;
    z:=3;
    for y:=1 to s.y do begin
      x:=1;
      while x<=s.x do begin
        read(c,1);
        read(b,1);
        s1.x:=x-1;
        s1.y:=y-1;
        if c=1 then begin
{          if config.GraphMode<>0 then
            TByteArray(p^)[z+x]:=b;
          else PutPix(x,b);}
          PutPixel(s1,b);
        end else
        begin
          setColor(b);
          setCursor(x-1,+y-1);
          s1.x:=x-2+c;
          s1.y:=y-1;
          LineTo(s1);
{          for l:=1 to c do
            if config.GraphMode<>0 then
              TByteArray(p^)[z+x+l-1]:=b
{            else PutPix(x+l-1,b);}
        end;
        inc(x,c);

      end;
{      if config.GraphMode=0 then begin
        ConvertPixRow16(TByteArray(p^)[z+1],s.x);
        inc(z,((s.x div 4)+byte(not not boolean(s.x mod 4)))*4+0)
      end else
        inc(z,s.x+1);}
    end;
  end;
{  PutImage(0,0,p^,NormalPut);
  FreeMem(p,4+s.x*s.y);}
end;

{$F+}
constructor TMyBIOSFont.Load(var s:TStream);{㧪 䮭}
begin
  s.Read(FontName[0],1);
  s.Read(FontName[1],length(fontName));
  s.read(CharHeight,2);
  GetMem(ImageTable,CharHeight*256);{!!!}
  s.read(ImageTable^,256*CharHeight);
  firstChar:=0;
  CharCount:=255;
  CharWidth:=8;
  Bytes:=CharHeight;
end;

procedure TMyBIOSFont.Store(var s:TStream);{࠭ 䮭}
begin
  s.write(FontName,Length(fontName)+1);
  s.write(CharHeight,2);
  s.write(ImageTable^,CharHeight*256);
end;

constructor TMy8x8BIOSFont.Load(var s:TStream);
begin
  firstChar:=0;
  CharCount:=255;
  CharWidth:=8;
  Bytes:=CharHeight;
  s.Read(FontName[0],1);
  s.Read(FontName[1],length(fontName));
  s.read(CharHeight,2);
  GetMem(ImageTable,CharHeight*128);{!!!}
  s.read(ImageTable^,128*CharHeight);
  GetMem(top,CharHeight*128);{!!!}
  s.read(top^,128*CharHeight);
end;

procedure TMy8x8BIOSFont.Store(var s:TStream);
begin
  s.write(FontName,Length(fontName)+1);
  s.write(CharHeight,2);
  s.write(ImageTable^,CharHeight*128);
  s.write(Top^,CharHeight*128);
end;
{$F-}


begin
  RegisterType(RMBmpFilter);
  RegisterType(RMBIOSFont);
  RegisterType(RM8x8BIOSFont);
  RegisterType(RMSI);
end.
