program Setup;
{$M 32000,0,655360}
{$X+,D+}
{$Define DEBUG}
uses {Dos,}Crt,{LowGraph,GFonts,}Graph,Objects,{ExtObj,}EventMan,
     Memory,GraV,Controls,GraMenu,Grapp,MsgBox,{GStdDlg,}Gadgets,
     {GrDriver,Images,Xms,}funcmain,{mstring,}validate,cfg,mobj,gfonts,
     Func_Ops;

const
  cmSaveSet =1000;
  cmRestSet =1001;
  cmSetDef  =1002;
  cmOptions =1003;
  cmRegs    =1004;

type
   GMyApp = object(GraphApplication)
{$IfDef DEBUG}
      Heap : PHeapView;
{$Endif}
      Clock : PClockView;
      constructor Init;
      procedure Idle; virtual;
      procedure HandleEvent(var Event : TEvent); virtual;
      procedure InitMenuBar; virtual;
      procedure InitStatusLine; virtual;
   end;

  PMValid=^MValid;
  MValid=object(TRangeValidator)
           procedure Error;virtual;
{           function IsValid(const S: string): Boolean; virtual;}
{           function IsValidInput(var S: string;
             SuppressFill: Boolean): Boolean;virtual;}
         end;

  PMValid2=^MValid2;
  MValid2=object(MValid)
           x_1,x_2:extended;
           constructor Init(AMin, AMax: Extended);
           function IsValid(const S: string): Boolean;virtual;
           function Transfer(var S: String; Buffer: Pointer;
             Flag: TVTransfer): Word;virtual;
{           function IsValid(const S: string): Boolean; virtual;}
{           function IsValidInput(var S: string;
             SuppressFill: Boolean): Boolean;virtual;}
         end;

const
  HeapSize = 250 * (1024 div 16);

var
  MyApp : GMyApp;
  MaxX, MaxY  : word;     { The maximum resolution of the screen }
  ErrorCode   : integer;  { Reports any graphics errors }
  MaxColor    : word;     { The maximum color value available }
  OldExitProc : Pointer;  { Saves exit procedure address }
{  PathToDriver : string;}
  Ch : Char;
  i : integer;
  MyCfg:TIniRecord;

procedure DoOptions;forward;
procedure DoRegs;forward;

constructor GMyApp.Init;
var
   R : TRect;
   ev: TEvent;
  ResStream : PBufStream;
  ResFile : PResourceFile;
begin
{$IfDef DEBUG}
   MaxHeapSize := HeapSize;
{$EndIf}
   GraphApplication.Init;
     new(ResStream,init('Objects.res',stOpenRead,2048));
     new(ResFile,init(ResStream));
     dispose(PFont(Fonts^.items^[1]),done);
     Fonts^.items^[1]:=ResFile^.get('Font8x8');
     dispose(PFont(Fonts^.items^[2]),done);
     Fonts^.items^[2]:=ResFile^.get('Font8x14');
     dispose(PFont(Fonts^.items^[3]),done);
     Fonts^.items^[3]:=ResFile^.get('Font8x16');
     dispose(ResFile,done);
   GetExtent(R);
   R.A.X := R.B.X - 74;
   inc(R.A.Y);
   R.B.Y := R.A.Y + 14;
   Clock := New(PClockView,Init(R));
   Insert(Clock);
{$IfDef DEBUG}
   GetExtent(R);
   dec(R.B.Y,2);
   R.A.Y := R.B.Y - 14;
   R.A.X := R.B.X - 74;
   dec(R.B.X,2);
   Heap := New(PHeapView,Init(R));
   Insert(Heap);
{$EndIf}
{   Message(application,evCommand,cmOptions,nil);}
   ev.what:=evCommand;
   ev.Command:=cmOptions;
   putEvent(ev);
{   DoOptions;}
end;

procedure GMyApp.Idle;

function IsTileable(P: PGraphView): Boolean; far;
begin
  IsTileable := P^.Options and ofTileable <> 0;
end;

begin
  GraphApplication.Idle;
  Clock^.Update;
{$IfDef DEBUG}
  Heap^.Update;
{$EndIf}
{  Message(DeskTop,evBroadcast,cmIdle,nil);}
end;


procedure GMyApp.InitMenuBar;
var R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + MenuItemHeight;
  MenuBar := New(PGraphMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ile', hcNoContext, NewMenu(
      NewItem('~O~ptions dialog', 'Alt-O', kbAltO, cmOptions, hcNoContext,
      NewItem('R~e~gisters dialog', 'Alt-R', kbAltR, cmRegs, hcNoContext,
      NewItem('~S~ave settings', 'Alt-S', kbAltS, cmSaveSet, hcNoContext,
      NewItem('~R~estore settings', '', kbNoKey, cmRestSet, hcNoContext,
      NewItem('S~e~t default', '', kbNoKey, cmSetDef, hcNoContext,
      NewLine(
      NewItem('~D~os shell', 'Alt-D', kbAltD{NoKey}, cmDosShell, hcDosShell,
      NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit, hcExit,
      nil))))))))),
    nil))
  ));
{  MenuBar}
end;

procedure GMyApp.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - StatusItemHeight;
  New(StatusLine, Init(R,
    NewStatusDef(0,0,{ $FFFF,}
      NewStatusKey('~O~ptions dialog', kbAltO, cmOptions,
      NewStatusKey('~S~ave', kbAltS, cmSaveSet,
      NewStatusKey('~R~estore', kbNoKey, cmRestSet,
      NewStatusKey('S~e~t default', kbNoKey, cmSetDef,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      nil)))))),
    nil)));
end;

procedure GMyApp.HandleEvent(var Event : TEvent);
var
   R : TRect;
   R1,R2 : TRect;
   W : word;
   Wnd,Child : PGraphWindow;

function dif(var r1,r2:TIniRecord):boolean;assembler;
const sz=SizeOf(TIniRecord);
asm
  push ds
  les di,r1
  lds si,r2
  mov cx,sz
  cld
  rep cmpsb
  jz @@1
  mov al,1
  jmp @@2
@@1:
  xor ax,ax
@@2:
  pop ds
end;

begin
  if (Event.what=evCommand)and(event.command=cmQuit)and(Dif(MyCfg,config)) then begin
    w:=MessageBox('Save settings?',nil,mfConfirmation or mfYesNoCancel);
    if w=cmCancel then
      ClearEvent(event);
    if w=cmYes then
      SaveSettings;
  end;
  GraphApplication.HandleEvent(Event);
  case Event.What of
    evCommand:
      case Event.Command of
        cmDosShell: DosShell;
        cmTile: Tile;
        cmCascade: Cascade;
        cmSaveSet:SaveSettings;
        cmRestSet:ReadSettings;
        cmSetDef:SetDefault;
        cmOptions:DoOptions;
        cmRegs:DoRegs;
{        cmHelp:Help;}
      else
        Exit;
      end;
  else
    Exit;
  end;
  ClearEvent(Event);
end;

procedure DoOptions;
Type ROpt=record
            x,y:string[4];{ࠧ Scale}
            x0,y0:string[5];{ᬥ饭}
            Ig:Word;{IsGrid}
            XSt:string[05];{XStep}
            pmi,pma:string[80];
            Lang:word;
            addopt:word;
            GrMode:word;
            Dlt:string[8];
            EZer:string[8];
            FncMode:word;
          end;

var r:TRect;
    wnd:PGraphDialog;
    Control: Word;
    Ln:PGraphInputLine;
    Vld:PMValid;
    Vld2:PMValid2;
    p:pointer;
    Opt:ROpt;
    Chk:PGraphCheckBoxes;
    Rad:PGraphRadioButtons;
    i:integer;
    b,re:boolean;

begin
  R.Assign(000,000,320,360);
  R.Move((GetMaxX-(r.b.x-r.a.x))div 2,(GetMaxY-(r.b.y-r.a.y))div 2);
  wnd:=new(PGraphDialog,init(r,'Options'));
  str(config.XScale,Opt.x);
  str(config.YScale,Opt.y);
  str(config.X0,Opt.x0);
  str(config.Y0,Opt.y0);
  str(config.XStep:5:3,Opt.XSt);
  Opt.lang:=Config.language+1;
  Opt.GrMode:=config.GraphMode+1;
  Opt.FncMode:=config.FncMode+1;
  opt.addopt:=byte(config.use387)or(byte(config.DDraw)shl 1)or(byte(config.DInit)shl 2);
  If config.IsGrid then Opt.ig:=1 else Opt.ig:=0;
  str(config.Delta:8:6,Opt.Dlt);
  str(config.EZero:8:6,Opt.EZer);
  opt.pmi:=SimpleNum(config.pmin);
  opt.pma:=SimpleNum(config.pmax);

  with wnd^ do begin
    r.assign(070,290,143,329);
    Insert(new(PGraphBitmapButton,Init(r,'OK',cmOK,bfDefault)));
    r.assign(177,290,240,329);
    insert(New(PGraphBitmapButton,Init(R,'CANCEL',cmCancel,bfNormal)));

    R.Assign(34,008,077,028);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,4));
    Vld:=new(PMValid,init(1,9999));
    Ln^.SetValidator(Vld);
    Insert(Ln);
    R.Assign(10, 010, 49, 026);{x-=30}
    Insert(New(PGraphLabel, Init(R, '~X~: ', Ln)));

    R.Assign(34,038,077,058);{x-=40}
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,4));
    Vld:=new(PMValid,init(1,9999));
    Ln^.SetValidator(Vld);
    Insert(Ln);
    R.Assign(10, 040, 49, 056);{x-=30}
    Insert(New(PGraphLabel, Init(R, '~Y~: ', Ln)));

    R.Assign(117,008,170,028);{x-=50}
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,5));
    Vld:=new(PMValid,init(-99999,99999));
    Ln^.SetValidator(Vld);
    Insert(Ln);
    R.Assign(085, 010,124, 026);{x-=40}
    Insert(New(PGraphLabel, Init(R, '~X0~: ', Ln)));

    R.Assign(117,038,170,058);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,5));
    Vld:=new(PMValid,init(-99999,99999));
    Ln^.SetValidator(Vld);
    Insert(Ln);
    R.Assign(085, 040,116, 056);
    Insert(New(PGraphLabel, Init(R, '~Y0~: ', Ln)));

    R.Assign(160,073,270,093);
    Chk := New(PGraphCheckBoxes,Init(R,
      NewSItem('~G~rid',nil)));
    Insert(Chk);

    R.Assign(77,073,130,093);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,5));
    Vld2:=new(PMValid2,init(0.0009,0.10000001));
    Ln^.SetValidator(Vld2);
    Insert(Ln);
    R.Assign(025, 075,080, 091);
    Insert(New(PGraphLabel, Init(R, 'X~S~tep:', Ln)));

    R.Assign(50,100,140,120);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,80));
    Insert(Ln);
    R.Assign(05, 102,46, 118);
    Insert(New(PGraphLabel, Init(R, 'PM~i~n=', Ln)));

    R.Assign(200,100,300,120);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,80));
    Insert(Ln);
    R.Assign(150, 102,193, 118);
    Insert(New(PGraphLabel, Init(R, 'PM~a~x=', Ln)));

    R.Assign(20,140,095,180);
    Rad := New(PGraphRadioButtons,Init(R,
      NewSItem('~R~us',
      NewSItem('~E~ng',nil))));
    Insert(Rad);
    R.Assign(020, 122,100, 138);
    Insert(New(PGraphLabel, Init(R, '~L~anguage',Rad)));

    R.Assign(10,200,105,260);
{    Rad := New(PGraphCheckBoxes,Init(R,
      NewSItem('~3~87',
      NewSItem('~D~Draw',nil))));}
    chk:=New(PGraphCheckBoxes,Init(R,
      NewSItem('~3~87',
      NewSItem('~D~Draw',
      NewSItem('D~I~nit',nil)))));
    Insert(chk);
    R.Assign(015,185,105,200);
    Insert(New(PGraphLabel, Init(R, '~O~ther',Chk)));

    R.Assign(115,150,290,230);
    Rad := New(PGraphRadioButtons,Init(R,
      NewSItem(' Vga  640x480x16 ',
      NewSItem('Vesa  640x480x256',
      NewSItem('Vesa  800x600x256',
      NewSItem('Vesa 1024x768x256',
      nil))))));
    Insert(Rad);
    R.Assign(145, 132,225, 148);
    Insert(New(PGraphLabel, Init(R, '~V~ideo mode',Rad)));

    R.Assign(185,235,290,280);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Assign(190,240,285,256);
    Ln:=new(PGraphInputLine,init(r,8));
    Vld:=new(PMValid2,init(0.0000001,0.085));
    Ln^.SetValidator(Vld);
    Insert(Ln);
    R.Assign(125, 240,180, 255);
    Insert(New(PGraphLabel, Init(R, '~D~elta: ', Ln)));
    R.Assign(190,260,285,270);
    Ln:=new(PGraphInputLine,init(r,8));
    Vld:=new(PMValid2,init(0.0000001,0.085));
    Ln^.SetValidator(Vld);
    Insert(Ln);
    R.Assign(125, 260,180, 275);
    Insert(New(PGraphLabel, Init(R, '~E~Zero: ', Ln)));

    R.Assign(180,023,300,060);
    Rad:=New(PGraphRadioButtons,Init(R,
      NewSItem('~C~artesian',
      NewSItem('~P~olar    ',
        nil))));
    Insert(Rad);
    R.Assign(195,004,300,020);
    Insert(New(PGraphLabel, Init(R, '~C~oordinates',Rad)));

    setData(opt);
  end;

 repeat
  re:=true;
  Control := DeskTop^.ExecView(Wnd);
  if control=cmOk then begin
    Wnd^.getData(Opt);
    val(opt.x,config.XScale,i);
    val(opt.y,config.YScale,i);
    val(opt.x0,config.X0,i);
    val(opt.y0,config.y0,i);
    if opt.Ig=0 then config.IsGrid:=false else config.IsGrid:=true;
    val(opt.XSt,config.XStep,i);
    config.Language:=opt.lang-1;
    config.GraphMode:=opt.GrMode-1;
    config.use387:=boolean(opt.addopt and 1);
    config.ddraw:=boolean((opt.addopt and 2)shr 1);
    config.dinit:=boolean((opt.addopt and 4)shr 2);
    config.FncMode:=Opt.FncMode-1;
    val(opt.dlt,config.delta,i);
    val(opt.EZer,config.EZero,i);
    case opt.GrMode of
     1..2:
       begin
         config.wx:=3*640 div 4;
         config.wy:=3*480 div 4;
       end;
     3:
       begin
         config.wx:=3*800 div 4;
         config.wy:=3*600 div 4;
       end;
     4:
       begin
         config.wx:=3*1024 div 4;
         config.wy:=3*768 div 4;
       end;
    end;

        prepare(opt.pmi);
        FError:=false;
        CheckFunc(opt.pmi);
        if FError then re:=false;
        if (not FError)and(not FuncValid(CalcStr(opt.pmi,Config.EZero))) then
          config.pmin:=CalcStr(opt.pmi,config.EZero);
        prepare(opt.pma);
        FError:=false;
        CheckFunc(opt.pma);
        if FError then re:=false;
        if (not FError)and(not FuncValid(CalcStr(opt.pma,Config.EZero))) then
          config.pmax:=CalcStr(opt.pma,config.EZero);

{    FWnd^.draw;}
  end; {else if Not b then FWnd^.draw;}
 until re;
  dispose(wnd,done);
end;

procedure MValid.Error;
begin
  Sound(400);
  delay(100);
  NoSound;
end;

constructor MValid2.Init(AMin, AMax: Extended);
begin
  TFilterValidator.Init(['0'..'9','+','-','.']);
  if AMin >= 0 then ValidChars := ValidChars - ['-'];
  X_1 := AMin;
  X_2 := AMax;
end;

function MValid2.IsValid(const S: string): Boolean;
var
  Value: extended;
  Code: Integer;
begin
  IsValid := False;
  if TFilterValidator.IsValid(S) then
  begin
    Val(S, Value, Code);
    if (Code=0)and(Value>=X_1)and(Value<=X_2) then
      IsValid := True;
  end;
end;

function MValid2.Transfer(var S: String; Buffer: Pointer;
  Flag: TVTransfer): Word;
var
  Value: Single;
  Code: Integer;
begin
  if Options and voTransfer <> 0 then
  begin
    Transfer := SizeOf(Value);
    case Flag of
     vtGetData:
       begin
         Val(S, Value, Code);
         Single(Buffer^) := Value;
       end;
     vtSetData:
       Str(Single(Buffer^), S);
    end;
  end
  else
    Transfer := 0;
end;

procedure DoRegs;
Type ROpt=record
            RegArr:array[0..9] of string[40];
          end;

var r:TRect;
    wnd:PGraphDialog;
    Control: Word;
    Ln:PGraphInputLine;
    Opt:ROpt;
    i:integer;
    b,re:boolean;

begin
  R.Assign(000,000,250,315);
  R.Move((GetMaxX-(r.b.x-r.a.x))div 2,(GetMaxY-(r.b.y-r.a.y))div 2);
  wnd:=new(PGraphDialog,init(r,'Registers'));
  for i:=0 to 9 do begin
    opt.RegArr[i]:=SimpleNum(config.Regs[i]);
  end;
  with wnd^ do begin
    r.assign(050,248,113,287);
    Insert(new(PGraphBitmapButton,Init(r,'OK',cmOK,bfDefault)));
    r.assign(132,248,195,287);
    insert(New(PGraphBitmapButton,Init(R,'CANCEL',cmCancel,bfNormal)));

    R.Assign(50,008,230,028);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 010,40, 026);
    Insert(New(PGraphLabel, Init(R, ' R~0~=', Ln)));

    R.Assign(50,032,230,052);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 034,40, 051);
    Insert(New(PGraphLabel, Init(R, ' R~1~=', Ln)));

    R.Assign(50,056,230,076);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(04, 058,40, 074);
    Insert(New(PGraphLabel, Init(R, ' R~2~=', Ln)));

    R.Assign(50,080,230,100);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 082,40, 099);
    Insert(New(PGraphLabel, Init(R, ' R~3~=', Ln)));

    R.Assign(50,104,230,124);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(5, 106,40, 120);
    Insert(New(PGraphLabel, Init(R, ' R~4~=', Ln)));

    R.Assign(50,128,230,148);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 130,40, 148);
    Insert(New(PGraphLabel, Init(R, ' R~5~=', Ln)));

    R.Assign(50,152,230,172);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 154,40, 170);
    Insert(New(PGraphLabel, Init(R, ' R~6~=', Ln)));

    R.Assign(50,176,230,196);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(5, 178,40, 194);
    Insert(New(PGraphLabel, Init(R, ' R~7~=', Ln)));

    R.Assign(50,200,230,220);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(05, 202,40, 218);
    Insert(New(PGraphLabel, Init(R, ' R~8~=', Ln)));

    R.Assign(50,224,230,244);
    Wnd^.Insert(New(PGraphGrayGroup,Init(R)));
    R.Grow(-4,-4);
    r.Move(2,0);
    Ln:=new(PGraphInputLine,init(r,40));
    Insert(Ln);
    R.Assign(5, 226,40, 242);
    Insert(New(PGraphLabel, Init(R, ' R~9~=', Ln)));

    setData(opt);
  end;

  repeat
    Control := DeskTop^.ExecView(Wnd);
    re:=true;
    if control=cmOk then begin
      Wnd^.getData(Opt);
      for i:=0 to 9 do begin
        prepare(opt.RegArr[i]);
        FError:=false;
        CheckFunc(opt.RegArr[i]);
        if FError then re:=false;
        if (not FError)and(not FuncValid(CalcStr(opt.RegArr[i],Config.EZero))) then
          config.Regs[i]:=CalcStr(opt.RegArr[i],config.EZero);
      end;
      SaveSettings;
    end;
  until re;
  dispose(wnd,done);
end;

begin
  ReadSettings;
  MyCfg:=config;
{  CurStr:=FuncStr;
  DriverType := Vesa256;
  DriverMode := Vesa256_800x600;
  VesaDriverNames[Vesa256] := 'videodr';
  Vesa256Modes[Vesa256_640x400] := 1;
  Vesa256Modes[Vesa256_640x480] := 2;
  Vesa256Modes[Vesa256_800x600] := 3;
  Vesa256Modes[Vesa256_1024x768] := 4;
  Vesa256Modes[Vesa256_1280x1024] := 5;
  EmulateMouseCursor := true;}
  MyApp.Init;
    DoneSysError;
    DoneEvents;
    SetGraphMode(GetGraphMode);
    InitEvents;
    InitSysError;
    MyApp.Redraw;
  MyApp.Run;
  MyApp.Done;
end.