unit x87;
interface
uses cfg;

const
    _e      :extended=2.718281828459045240;
    _onehalf:extended=0.5;

const
      c_fabs=$E1D9;
      c_fadd=$C1DC;
      c_faddp=$C1DE;
      c_fchs=$E0D9;
      c_fcompp=$D9DE;
      c_fdivp=$F9DE;
      c_fdivrp=$F1DE;
      c_fildw_bp=$86DF;
      c_fildd_bp=$86DB;
      c_fildq_bp=$AEDF;
      c_fistpd_bp=$9EDB;
      c_fistpq_bp=$BEDF;
      c_fld=$2EDB;
      c_fldcw_bp=$AED9;
      c_fldcw=$2ED9;
      c_fldlg2=$ECD9;
      c_fldln2=$EDD9;
      c_fldl2e=$EAD9;
      c_fldpi=$EBD9;
      c_fldz=$EED9;
      c_fld1=$E8D9;
      c_fld_bp=$AEDB;
      c_fld_st=$C0D9;
      c_fld_st0=$C0D9;
      c_fmul=$C9DC;
      c_fmulp=$C9DE;
      c_fpatan=$F3D9;
      c_frndint=$FCD9;
      c_fscale=$FDD9;
      c_fsin=$FED9;
      c_fcos=$FFD9;
      c_fsqr=$C8DC;
      c_fsqrt=$FAD9;
      c_fstcw_bp=$BED9;
      c_fstcw=$3ED9;
      c_fstp=$3EDB;
      c_fstp_bp=$BEDB;
      c_fstp_bx=$BFDB;
      c_fstp_st0=$D8DD;
      c_fstp_st1=$D9DD;
      c_fstsw_ax=$E0DF;
      c_fsub=$E9DC;
      c_fsubp=$E9DE;
      c_fsubrp=$E1DE;
      c_fsub_st1=$E9DC;
      c_ftst=$E4D9;
      c_fxam=$E5D9;
      c_fxch=$C9D9;
      c_fyl2x=$F1D9;
      c_f2xm1=$F0D9;

      p_cs=$2e;
      p_ds=$3e;
      p_es=$26;
      p_ss=$36;

      cw_rcm=$0C00;
      sw_cn1=$8500;
      sw_c=$8700;
      sw_pln=$0400;
      sw_mnn=$0600;
      sw_stl=$0100;

function __zero:boolean;
function f_plus(a,b:extended):extended;
function f_minus(a,b:extended):extended;
function f_mul(a,b:extended):extended;
function f_div(a,b:extended):extended;
function f_e:extended;
function f_pi:extended;

implementation

function __zero:boolean;assembler;
asm
  dw c_fld_st0
  dw c_fabs
  dw c_fld, config.delta
{  dw c_fxch}
  dw c_fcompp
  dw c_fstsw_ax
  and ah,01000101b
  test ah,00000100b
  jz @@l1
{  dw c_fld, _ezero}
  xor al,al
  jmp @@fin
@@l1:
  or ah,ah
  jnz @@l2
  mov al,1
  jmp @@fin
@@l2:
  xor al,al
@@fin:
end;

function f_plus(a,b:extended):extended;assembler;
asm
  dw c_fld_bp,a
  dw c_fld_bp,b
  dw c_faddp
end;

function f_minus(a,b:extended):extended;assembler;
asm
  dw c_fld_bp,a
  dw c_fld_bp,b
  dw c_fsubp
end;

function f_mul(a,b:extended):extended;assembler;
asm
  dw c_fld_bp,a
  dw c_fld_bp,b
  dw c_fmulp
end;

function f_div(a,b:extended):extended;assembler;
asm
  dw c_fld_bp,b
  call __zero
  or al,al
  jz @@l1
  dw c_fstp_st1-$100
  dw c_fld,config.ezero
  jmp @@fin
@@l1:
  dw c_fld_bp,a
  dw c_fdivrp
@@fin:
end;

function f_e:extended;assembler;
asm
  dw c_fld,_e
end;

function f_pi:extended;assembler;
asm
  dw c_fldpi
end;

end.